#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES6-00
class Ues::Core::Attachment::UESAttachment
  private_class_method :new

  BEATTACHMENT_CODE = Java::cz.ues.core.attachment.UESAttachment::BEATTACHMENT_CODE #:nodoc:

  # URI of attachment business entity.
# 
# <tt><b>since</b></tt> UES6-06
  BETYPE_ATTACHMENT = Java::cz.ues.core.attachment.UESAttachment::BETYPE_ATTACHMENT


# This command creates a new attachment to the specified artifact. At the
# very least attachment data and filename have to be specified in this
# command. The data are streamed.
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact where the new attachment is
# created
# 
# <tt><b>param</b></tt> attachment DTO containing attributes of a new attachment
# 
# <tt><b>return</b></tt> UESURI of the new attachment
# 
# <tt><b>throws</b></tt> UESAttachmentRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.create(artifactUri, attachment = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    attachment = Ues::Core::Attachment::UESAttachmentCreate.new(attachment).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.attachment.UESAttachment.java_class)
    _r = _s.create(artifactUri, attachment)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Returns attributes representing the attachment specified by the
# <code>attachmentUri</code> attribute. If the attachment is locked by the
# current user, this command returns attributes of the private version. If
# the attachment is locked by another user (or if the attachment is
# unlocked), the command returns attributes of the public version. The
# command does not change the state of the attachment or its lock in the
# system.
# 
# <tt><b>param</b></tt> attachmentUri UESURI of the attachment
# 
# <tt><b>return</b></tt> DTO with attachment attributes
# 
# <tt><b>throws</b></tt> UESAttachmentRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.getAttributes(attachmentUri)
    attachmentUri = Ues::Core::Commons::Uri::UESURI.new(attachmentUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.attachment.UESAttachment.java_class)
    _r = _s.getAttributes(attachmentUri)
    if (_r != nil) then _r = Ues::Core::Attachment::UESAttachmentAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Attachment::UESAttachment
    alias attributes getAttributes
  end

# Retrieves a UESResult list of attachments for the artifact
# specified by the <code>artifactUri</code> parameter. The resulting
# attachment list is filtered according to the criteria provided by the
# <code>criteria</code> attribute. These criteria specify the page to return
# and name and code filters. The list is sorted (ascending) according to the
# attachment name and code.
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact to get the list of attachments
# from.
# 
# <tt><b>param</b></tt> criteria DTO containing paging and filtering criteria.
# Available parameters are: UESAttachmentAttributes#name name, UESAttachmentAttributes#code code, UESAttachmentAttributes#locked locked and UESAttachmentAttributes#lockTime lockTime.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery Documentation.</a>
# 
# <tt><b>return</b></tt> list of attachments.
# 
# <tt><b>throws</b></tt> UESAttachmentRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.getAttachmentList(artifactUri, criteria = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    criteria = Ues::Core::Attachment::UESAttachmentGetAttachmentList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.attachment.UESAttachment.java_class)
    _r = _s.getAttachmentList(artifactUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Attachment::UESAttachment
    alias attachment_list getAttachmentList
  end

# Command locks the attachment specified by the <code>attachmentUri</code>
# attribute. If the operation is successful or if the attachment is already
# locked by the current user, attachment stream handler or null is returned
# depending on the options set in the attribute <code>options</code>. If the
# attachment cannot be locked because the attachment is locked by another
# user, the command will fail.
# 
# <tt><b>param</b></tt> attachmentUri UESURI of the attachment
# 
# <tt><b>param</b></tt> options DTO with options containing a flag whether to return the
# stream with attachment data
# 
# <tt><b>return</b></tt> data content of the attachment or null depending on the options set
# in <code>options</code> attribute
# 
# <tt><b>throws</b></tt> UESAttachmentRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.checkOut(attachmentUri, options = nil)
    attachmentUri = Ues::Core::Commons::Uri::UESURI.new(attachmentUri).to_java
    options = Ues::Core::Attachment::UESAttachmentCheckOut.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.attachment.UESAttachment.java_class)
    _r = _s.checkOut(attachmentUri, options)
    if (_r != nil) then _r = Ues::Core::Attachment::UESAttachmentStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Attachment::UESAttachment
    alias check_out checkOut
  end

# This command updates the attached file in the system and unlocks it by
# default. The command succeeds if the attachment is unlocked or if it is
# locked by the current user. Otherwise, the command fails. At the very least
# attachment data and the filename have to be specified in this command. The
# data are streamed.
# 
# <tt><b>param</b></tt> attachmentUri UESURI of the attachment
# 
# <tt><b>param</b></tt> attachment DTO containing attributes of the checked-in attachment
# 
# <tt><b>throws</b></tt> UESAttachmentRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.checkIn(attachmentUri, attachment = nil)
    attachmentUri = Ues::Core::Commons::Uri::UESURI.new(attachmentUri).to_java
    attachment = Ues::Core::Attachment::UESAttachmentCheckIn.new(attachment).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.attachment.UESAttachment.java_class)
    _r = _s.checkIn(attachmentUri, attachment)
    
    return _r
  end
  class << Ues::Core::Attachment::UESAttachment
    alias check_in checkIn
  end

# Command returns stream handler containing data content of the attachment.
# If the attachment is locked by the same user, command returns data of the
# private version. If the attachment is locked by another user (or if the
# attachment is unlocked), command returns data of the public version.
# Command does not change the state of the attachment or its lock in the
# system.
# 
# <tt><b>param</b></tt> attachmentUri UESURI of the attachment
# 
# <tt><b>return</b></tt> DTO with attachment data content
# 
# <tt><b>throws</b></tt> UESAttachmentRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.getAttachmentData(attachmentUri)
    attachmentUri = Ues::Core::Commons::Uri::UESURI.new(attachmentUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.attachment.UESAttachment.java_class)
    _r = _s.getAttachmentData(attachmentUri)
    if (_r != nil) then _r = Ues::Core::Attachment::UESAttachmentStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Attachment::UESAttachment
    alias attachment_data getAttachmentData
  end

# This command deletes the attachment from the system.
# 
# <tt><b>param</b></tt> attachmentUri UESURI of the attachment which is about to be deleted.
# 
# <tt><b>since</b></tt> UES6-10
  def self.delete(attachmentUri)
    attachmentUri = Ues::Core::Commons::Uri::UESURI.new(attachmentUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.attachment.UESAttachment.java_class)
    _r = _s.delete(attachmentUri)
    
    return _r
  end

# This command updates basic attributes of an attachment.
# 
# <tt><b>param</b></tt> attachmentUri UESURI of the attachment whose attributes are to be changed.
# 
# <tt><b>param</b></tt> attachment DTO containing the attachment attributes.
# 
# <tt><b>return</b></tt> UESURI of the attachment
# 
# <tt><b>throws</b></tt> UESAttachmentRTException
# 
# <tt><b>since</b></tt> UES7-12
  def self.setAttributes(attachmentUri, attachment = nil)
    attachmentUri = Ues::Core::Commons::Uri::UESURI.new(attachmentUri).to_java
    attachment = Ues::Core::Attachment::UESAttachmentSetAttributes.new(attachment).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.attachment.UESAttachment.java_class)
    _r = _s.setAttributes(attachmentUri, attachment)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Attachment::UESAttachment
    alias set_attributes setAttributes
  end

# Returns attributes an attachment version by provided ID.
# 
# <tt><b>param</b></tt> attachmentUri UESURI of the attachment whose version's attributes are going to be retrieved.
# 
# <tt><b>param</b></tt> versionAttributes Object containing id of the attachment version, whose attributes are going to be retrieved.
# 
# <tt><b>return</b></tt> Object containing the attributes of the attachment version.
# 
# <tt><b>throws</b></tt> UESAttachmentRTException
# 
# <tt><b>since</b></tt> UES8-17
  def self.getVersionAttributes(attachmentUri, versionAttributes = nil)
    attachmentUri = Ues::Core::Commons::Uri::UESURI.new(attachmentUri).to_java
    versionAttributes = Ues::Core::Attachment::UESAttachmentGetVersionAttributes.new(versionAttributes).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.attachment.UESAttachment.java_class)
    _r = _s.getVersionAttributes(attachmentUri, versionAttributes)
    if (_r != nil) then _r = Ues::Core::Attachment::UESAttachmentVersionAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Attachment::UESAttachment
    alias version_attributes getVersionAttributes
  end

# Returns a list of version for the specified attachment. Does not return all versions, only a sublist. The list of returned versions can be filtered by
# the attributes: name, code, label, creationTime, creationStamp and version. The list is sorted by the creation time of a version
# by default, or it can be sorted arbitrarily by any of the version attributes for the filtering or their combinations.
# 
# <tt><b>param</b></tt> attachmentUri UESURI of the attachment whose versions are going to be listed.
# 
# <tt><b>param</b></tt> versionCriteria Object containing criteria for listing attachment versions.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List of objects containing versions' attributes. The same object is returned by the command getVersionAttributes.
# 
# <tt><b>throws</b></tt> UESAttachmentRTException
# 
# <tt><b>since</b></tt> UES8-17
  def self.getVersionList(attachmentUri, versionCriteria = nil)
    attachmentUri = Ues::Core::Commons::Uri::UESURI.new(attachmentUri).to_java
    versionCriteria = Ues::Core::Attachment::UESAttachmentGetVersionList.new(versionCriteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.attachment.UESAttachment.java_class)
    _r = _s.getVersionList(attachmentUri, versionCriteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Attachment::UESAttachment
    alias version_list getVersionList
  end

# Deletes an attachment version by provided ID.
# 
# <tt><b>param</b></tt> attachmentUri UESURI of the attachment whose version is going to be deleted.
# 
# <tt><b>param</b></tt> version DTO containing ID of the version which is to be deleted.
# 
# <tt><b>throws</b></tt> UESAttachmentRTException
# 
# <tt><b>since</b></tt> UES8-17
  def self.deleteVersion(attachmentUri, version = nil)
    attachmentUri = Ues::Core::Commons::Uri::UESURI.new(attachmentUri).to_java
    version = Ues::Core::Attachment::UESAttachmentDeleteVersion.new(version).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.attachment.UESAttachment.java_class)
    _r = _s.deleteVersion(attachmentUri, version)
    
    return _r
  end
  class << Ues::Core::Attachment::UESAttachment
    alias delete_version deleteVersion
  end

# Retreives the data of the specified attachment version.
# 
# <tt><b>param</b></tt> attachmentUri UESURI of the attachment whose version is going to be retrieved.
# 
# <tt><b>param</b></tt> version Id of the attachment version, which data are going to be retrieved. Not null.
# 
# <tt><b>return</b></tt> UESAttachmentStreamHandler, containing XML of the attachment content structure of the given version.
# 
# <tt><b>throws</b></tt> UESAttachmentRTException
# 
# <tt><b>since</b></tt> UES8-17
  def self.getVersionData(attachmentUri, version = nil)
    attachmentUri = Ues::Core::Commons::Uri::UESURI.new(attachmentUri).to_java
    version = Ues::Core::Attachment::UESAttachmentGetVersionData.new(version).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.attachment.UESAttachment.java_class)
    _r = _s.getVersionData(attachmentUri, version)
    if (_r != nil) then _r = Ues::Core::Attachment::UESAttachmentStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Attachment::UESAttachment
    alias version_data getVersionData
  end
end
