#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES7-10
class Ues::Core::Container::UESCompany
  private_class_method :new

  BECOMPANY_CODE = Java::cz.ues.core.container.UESCompany::BECOMPANY_CODE #:nodoc:

  # URI of company business entity.
# 
# <tt><b>since</b></tt> UES7-10
  BETYPE_COMPANY = Java::cz.ues.core.container.UESCompany::BETYPE_COMPANY


# Creates a new company. The command creates a new company in a specified location. At the very least meta artifact must be specified in
# UESCompanyCreate DTO. Competent role for the company will be selected as the most suitable according to specified container and
# meta artifact (executive/authorized role with connected interface), or can be also specified in UESCompanyCreate DTO.
# 
# <tt><b>param</b></tt> locationUri UESURI of the container except meta model where the company is going to be created
# 
# <tt><b>param</b></tt> company DTO containing attributes of new company
# 
# <tt><b>return</b></tt> UESURI of the new company
# 
# <tt><b>throws</b></tt> UESCompanyRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.create(locationUri, company = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    company = Ues::Core::Container::UESCompanyCreate.new(company).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESCompany.java_class)
    _r = _s.create(locationUri, company)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command returns attributes representing the company specified by the companyUri parameter. The command does not change the state
# of the company in the system.
# 
# <tt><b>param</b></tt> companyUri UESURI of the company whose attributes are returned
# 
# <tt><b>return</b></tt> Filled DTO with attributes of the company
# 
# <tt><b>throws</b></tt> UESCompanyRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getAttributes(companyUri)
    companyUri = Ues::Core::Commons::Uri::UESURI.new(companyUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESCompany.java_class)
    _r = _s.getAttributes(companyUri)
    if (_r != nil) then _r = Ues::Core::Container::UESCompanyAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESCompany
    alias attributes getAttributes
  end

# Command for setting attributes of a company. The command cannot modify references to objects like location, competent role and so on.
# 
# <tt><b>param</b></tt> companyUri UESURI of the company whose attributes are to be changed.
# 
# <tt><b>param</b></tt> company DTO containing new attributes for company
# 
# <tt><b>return</b></tt> UESURI of the company
# 
# <tt><b>throws</b></tt> UESCompanyRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.setAttributes(companyUri, company = nil)
    companyUri = Ues::Core::Commons::Uri::UESURI.new(companyUri).to_java
    company = Ues::Core::Container::UESCompanySetAttributes.new(company).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESCompany.java_class)
    _r = _s.setAttributes(companyUri, company)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESCompany
    alias set_attributes setAttributes
  end

# This command deletes the specified company from the system. The company is deleted even if constains locked sheet or attachment. The
# company cannot be deleted when:
# 
# 
# * the company is not empty.
# 
# * the company's workflow is not created
# 
# * a property contains a reference to this company
# 
# * a time sheet exists with a reference to this company
# 
# 
# 
# 
# <tt><b>param</b></tt> companyUri UESURI of the company which is going to be deleted
# 
# <tt><b>throws</b></tt> UESCompanyRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.delete(companyUri)
    companyUri = Ues::Core::Commons::Uri::UESURI.new(companyUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESCompany.java_class)
    _r = _s.delete(companyUri)
    
    return _r
  end

# This command returns a list of entries (artifacts or shortcuts) enlisted in the specified company. Only entries listed exactly in the
# specified company are considered (so subordinate organizational units are not considered). The command does not return all entries,
# only a sublist. The list of returned entries could be filtered by the name, code or entityType of an entry. The list is sorted by the
# name (and codes in case are equal) of a entry by default, or it can be sorted arbitrarily by any of entry attributes usable for the
# filtering or these attributes combinations. See the UES query documentation for more information.
# 
# <tt><b>param</b></tt> companyUri UESURI of the company from where entries are listed
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing Available parameters are:
# cz.ues.core.container.dto.UESCompanyEntryAttributes#name name,
# cz.ues.core.container.dto.UESCompanyEntryAttributes#code code and
# cz.ues.core.container.dto.UESCompanyEntryAttributes#entityTypeUri entityTypeUri.
# 
# <tt><b>return</b></tt> List of DTO representing company entries
# 
# <tt><b>throws</b></tt> UESCompanyRTException
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>since</b></tt> UES7-10
  def self.getEntryList(companyUri, criteria = nil)
    companyUri = Ues::Core::Commons::Uri::UESURI.new(companyUri).to_java
    criteria = Ues::Core::Container::UESCompanyGetEntryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESCompany.java_class)
    _r = _s.getEntryList(companyUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESCompany
    alias entry_list getEntryList
  end
end
