#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Core::Container::UESFolderInterface #:nodoc:
  private_class_method :new

  BE_FOLDER_INTERFACE_CODE = Java::cz.ues.core.container.UESFolderInterface::BE_FOLDER_INTERFACE_CODE #:nodoc:

  # URI of folder interface business entity.
# 
# <tt><b>since</b></tt> UES8-04
  BETYPE_FOLDER_INTERFACE = Java::cz.ues.core.container.UESFolderInterface::BETYPE_FOLDER_INTERFACE


# The command exports a folder interface into a DataFile, which is saved to the Export Storage. The export is an asynchronous event. That
# is why it returns a process URI to enable the user to wait for the process to finish.
# 
# <tt><b>param</b></tt> folderInterfaceUri UESURI of the folder interface to export
# 
# <tt><b>param</b></tt> folderInterface DTO that contains attributes of the export process
# 
# <tt><b>return</b></tt> UESURI of the export process
# 
# <tt><b>throws</b></tt> UESFolderInterfaceRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.export(folderInterfaceUri, folderInterface = nil)
    folderInterfaceUri = Ues::Core::Commons::Uri::UESURI.new(folderInterfaceUri).to_java
    folderInterface = Ues::Core::Container::UESFolderInterfaceExport.new(folderInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESFolderInterface.java_class)
    _r = _s.export(folderInterfaceUri, folderInterface)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command returns a data file generated by the export command. The file contains an exported folder interface.
# 
# <tt><b>param</b></tt> folderInterfaceUri UESURI of the folder interface we want to get the exported file from.
# 
# <tt><b>param</b></tt> folderInterface DTO that contains attributes concerning the file returned.
# 
# <tt><b>return</b></tt> Data file of an exported folder interface.
# 
# <tt><b>throws</b></tt> UESFolderInterfaceRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.getExportData(folderInterfaceUri, folderInterface = nil)
    folderInterfaceUri = Ues::Core::Commons::Uri::UESURI.new(folderInterfaceUri).to_java
    folderInterface = Ues::Core::Container::UESFolderInterfaceGetExportData.new(folderInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESFolderInterface.java_class)
    _r = _s.getExportData(folderInterfaceUri, folderInterface)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESFolderInterface
    alias export_data getExportData
  end
end
