#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES6-06
class Ues::Core::Container::UESOrganizationalUnit
  private_class_method :new

  BEORGANIZATIONALUNIT_CODE = Java::cz.ues.core.container.UESOrganizationalUnit::BEORGANIZATIONALUNIT_CODE #:nodoc:

  # URI of organizational unit business entity.
# 
# <tt><b>since</b></tt> UES6-06
  BETYPE_ORGANIZATIONALUNIT = Java::cz.ues.core.container.UESOrganizationalUnit::BETYPE_ORGANIZATIONALUNIT


# Creates a new organizational unit. The command creates a new organizational unit in a specified location. At the very least meta
# artifact must be specified in UESOrganizationalUnitCreate DTO. Competent role for the organizational unit will be selected as
# the most suitable according to specified container and meta artifact (executive/authorized role with connected interface), or can be
# also specified in UESOrganizationalUnitCreate DTO.
# 
# <tt><b>param</b></tt> locationUri UESURI of the folder/org. unit/meta model where organizational unit will be created.
# 
# <tt><b>param</b></tt> DTO containing attributes of the new organizational unit
# 
# <tt><b>return</b></tt> UESURI of the new organizational unit
# 
# <tt><b>throws</b></tt> UESOrganizationalUnitRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.create(locationUri, organizationalUnit = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    organizationalUnit = Ues::Core::Container::UESOrganizationalUnitCreate.new(organizationalUnit).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESOrganizationalUnit.java_class)
    _r = _s.create(locationUri, organizationalUnit)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command returns attributes representing the organizational unit specified by the organizationalUnitUri parameter. The command does
# not change the state of the organizational unit in the system.
# 
# <tt><b>param</b></tt> organizationalUnitUri UESURI of an organizational unit whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the organizational unit attributes
# 
# <tt><b>throws</b></tt> UESOrganizationalUnitRTException
# 
# <tt><b>since</b></tt> UES6-06
  def self.getAttributes(organizationalUnitUri)
    organizationalUnitUri = Ues::Core::Commons::Uri::UESURI.new(organizationalUnitUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESOrganizationalUnit.java_class)
    _r = _s.getAttributes(organizationalUnitUri)
    if (_r != nil) then _r = Ues::Core::Container::UESOrganizationalUnitAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESOrganizationalUnit
    alias attributes getAttributes
  end

# Command for setting attributes of an organizational unit. The command can't modify references to objects like location, competent role
# and so on.
# 
# <tt><b>param</b></tt> organizationalUnitUri UESURI of the organizational unit whose attributes are to be changed
# 
# <tt><b>param</b></tt> organizationalUnit DTO containing new attributes the organizational unit
# 
# <tt><b>return</b></tt> UESURI of the organizational unit
# 
# <tt><b>throws</b></tt> UESOrganizationalUnitRTException
# 
# <tt><b>since</b></tt> UES6-06
  def self.setAttributes(organizationalUnitUri, organizationalUnit = nil)
    organizationalUnitUri = Ues::Core::Commons::Uri::UESURI.new(organizationalUnitUri).to_java
    organizationalUnit = Ues::Core::Container::UESOrganizationalUnitSetAttributes.new(organizationalUnit).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESOrganizationalUnit.java_class)
    _r = _s.setAttributes(organizationalUnitUri, organizationalUnit)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESOrganizationalUnit
    alias set_attributes setAttributes
  end

# This command deletes the specified organizational unit from the system. The organizational unit is deleted even if it contains a locked
# sheet or attachment. The organizational unit cannot be deleted when:
# 
# 
# * the org. unit is not empty.
# 
# * the org. unit's workflow is not created
# 
# * a property contains a reference to this org. unit
# 
# * a time sheet exists with a reference to this org. unit
# 
# 
# 
# 
# <tt><b>param</b></tt> orgUnitUri UESURI of the organizational unit which is about to be deleted.
# 
# <tt><b>throws</b></tt> UESOrganizationalUnitRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.delete(orgUnitUri)
    orgUnitUri = Ues::Core::Commons::Uri::UESURI.new(orgUnitUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESOrganizationalUnit.java_class)
    _r = _s.delete(orgUnitUri)
    
    return _r
  end

# This command returns a list of entries (artifacts or shortcuts) enlisted in the specified organizational unit. Only entries listed
# exactly in the specified organizational units are considered (so subordinate organizational units are not considered). The command does
# not return all entries, only a sublist. The list of returned entries could be filtered by the name, code or type of an entry. The list
# is sorted by the name (and codes in case are equal) of a entry by default, or it can be sorted arbitrarily by any of entry attributes
# usable for the filtering or these attributes combinations. See the UES query documentation for more information.
# 
# <tt><b>param</b></tt> organizationalUnitUri UESURI of the organizational unit from where entries (artifacts or shortcuts) are listed.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing entries Available parameters are: UESOrganizationalUnitEntryAttributes#name
# name, UESOrganizationalUnitEntryAttributes#code code and UESOrganizationalUnitEntryAttributes#type type :
# UESOrganizationalUnitEntryType UESOrganizationalUnitEntryType.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List of DTO representing entries of the organizationalUnitUri (artifacts or shortcuts).
  def self.getEntryList(organizationalUnitUri, criteria = nil)
    organizationalUnitUri = Ues::Core::Commons::Uri::UESURI.new(organizationalUnitUri).to_java
    criteria = Ues::Core::Container::UESOrganizationalUnitGetEntryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESOrganizationalUnit.java_class)
    _r = _s.getEntryList(organizationalUnitUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESOrganizationalUnit
    alias entry_list getEntryList
  end
end
