#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES6-02
class Ues::Core::Container::UESShortcut
  private_class_method :new

  BESHORTCUT_CODE = Java::cz.ues.core.container.UESShortcut::BESHORTCUT_CODE #:nodoc:

  # URI of shortcut business entity.
# 
# <tt><b>since</b></tt> UES6-06
  BETYPE_SHORTCUT = Java::cz.ues.core.container.UESShortcut::BETYPE_SHORTCUT


# This command creates a new shortcut for the specified artifact. At the very least, referenced artifact have to be specified in this
# command.
# 
# <tt><b>param</b></tt> locationUri UESURI of the location (folder, org. unit, territory etc.) where the new shortcut is created
# 
# <tt><b>param</b></tt> shortcut DTO containing attributes of the new shortcut
# 
# <tt><b>return</b></tt> UESURI of the created shortcut
# 
# <tt><b>throws</b></tt> UESShortcutRTException
# 
# <tt><b>since</b></tt> UES6-02
  def self.create(locationUri, shortcut = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    shortcut = Ues::Core::Container::UESShortcutCreate.new(shortcut).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESShortcut.java_class)
    _r = _s.create(locationUri, shortcut)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command returns attributes representing the shortcut specified by the shortcutUri parameter. The command does not change the state
# of the shortcut in the system.
# 
# <tt><b>param</b></tt> shortcutUri UESURI of a shortcut whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the shortcut attributes
# 
# <tt><b>throws</b></tt> UESShortcutRTException
# 
# <tt><b>since</b></tt> UES6-02
  def self.getAttributes(shortcutUri)
    shortcutUri = Ues::Core::Commons::Uri::UESURI.new(shortcutUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESShortcut.java_class)
    _r = _s.getAttributes(shortcutUri)
    if (_r != nil) then _r = Ues::Core::Container::UESShortcutAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESShortcut
    alias attributes getAttributes
  end

# This command returns a list of shortcuts to the specified artifact. The command does not return all shortcuts, only a sublist. Only the
# shortcuts from the territory of the artifact are returned. The list of returned shortcuts could be filtered by the name or code of a
# shortcut. The list is sorted by the name (and codes in case are equal) of a shortcut by default, or it can be sorted arbitrarily by any
# of shortcut attributes usable for the filtering or these attributes combinations. See the UES query documentation for more information.
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact to which the returned shortcuts point.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing shortcuts.
# Available parameters are: UESShortcutAttributes#name name and UESShortcutAttributes#code code.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery Documentation.</a>
# 
# <tt><b>return</b></tt> List of DTO representing shortcuts. The same DTO as in the command getAttributes.
# 
# <tt><b>throws</b></tt> UESShortcutRTException
# 
# <tt><b>since</b></tt> UES6-02
  def self.getShortcutList(artifactUri, criteria = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    criteria = Ues::Core::Container::UESShortcutGetShortcutList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESShortcut.java_class)
    _r = _s.getShortcutList(artifactUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESShortcut
    alias shortcut_list getShortcutList
  end

# This command relocates the shortcut to the new location. It means the shortcut is deleted and created again in a new location. It is
# recreated with the same attributes. But its UESURI is different because the shortcut is deleted and created again in another location.
# At the very least new location have to be specified in this command. The new location has to be in the same territory.
# 
# <tt><b>param</b></tt> shortcutUri UESURI of the shortcut to relocate
# 
# <tt><b>param</b></tt> shortcut DTO containing attributes for the shortcut relocation
# 
# <tt><b>return</b></tt> UESURI of the relocated shortcut. UESURI is different because the shortcut is deleted and created again in another location.
# 
# <tt><b>throws</b></tt> UESShortcutRTException
# 
# <tt><b>since</b></tt> UES6-02
  def self.relocate(shortcutUri, shortcut = nil)
    shortcutUri = Ues::Core::Commons::Uri::UESURI.new(shortcutUri).to_java
    shortcut = Ues::Core::Container::UESShortcutRelocate.new(shortcut).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESShortcut.java_class)
    _r = _s.relocate(shortcutUri, shortcut)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command deletes the shortcut from the system.
# 
# <tt><b>param</b></tt> shortcutUri UESURI of the shortcut to be deleted
# 
# <tt><b>throws</b></tt> UESShortcutRTException
# 
# <tt><b>since</b></tt> UES6-02
  def self.delete(shortcutUri)
    shortcutUri = Ues::Core::Commons::Uri::UESURI.new(shortcutUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESShortcut.java_class)
    _r = _s.delete(shortcutUri)
    
    return _r
  end

# This command updates some basic attributes of a shortcut.
# 
# <tt><b>param</b></tt> shortcutUri UESURI of the shortcut whose attributes are to be changed
# 
# <tt><b>param</b></tt> shortcut DTO containing new attributes the shortcut
# 
# <tt><b>return</b></tt> UESURI of the shortcut. It could be changed because command could change the code
# 
# <tt><b>throws</b></tt> UESShortcutRTException
# 
# <tt><b>since</b></tt> UES6-02
  def self.setAttributes(shortcutUri, shortcut = nil)
    shortcutUri = Ues::Core::Commons::Uri::UESURI.new(shortcutUri).to_java
    shortcut = Ues::Core::Container::UESShortcutSetAttributes.new(shortcut).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.container.UESShortcut.java_class)
    _r = _s.setAttributes(shortcutUri, shortcut)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Container::UESShortcut
    alias set_attributes setAttributes
  end
end
