#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES6-06
class Ues::Core::Personalrole::UESPersonalRole
  private_class_method :new

  BEPERSONALROLE_CODE = Java::cz.ues.core.personalrole.UESPersonalRole::BEPERSONALROLE_CODE #:nodoc:

  # URI of PersonalRole business entity.
# 
# <tt><b>since</b></tt> UES8-23
  BETYPE_PERSONALROLE = Java::cz.ues.core.personalrole.UESPersonalRole::BETYPE_PERSONALROLE


# Command for setting attributes of an personalRole. The command can't modify references to objects like location, competent role and so on.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of the Personal Role whose attributes are to be changed
# 
# <tt><b>param</b></tt> personalRole DTO containing new attributes the personalRole
# 
# <tt><b>return</b></tt> UESURI of the PersonalRole
# 
# <tt><b>throws</b></tt> UESPersonalRoleRTException
# 
# <tt><b>since</b></tt> UES8-23
  def self.setAttributes(personalRoleUri, personalRole = nil)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    personalRole = Ues::Core::Personalrole::UESPersonalRoleSetAttributes.new(personalRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.setAttributes(personalRoleUri, personalRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Personalrole::UESPersonalRole
    alias set_attributes setAttributes
  end

# Creates a new Personal Role to a specified location.
# 
# <tt><b>param</b></tt> locationUri UESURI of OU or folder in which the PersonalRole will be created.
# 
# <tt><b>param</b></tt> personalRole DTO containing the attributes of the PersonalRole.
# 
# <tt><b>return</b></tt> UESURI of the new PersonalRole.
# 
# <tt><b>throws</b></tt> UESPersonalRoleRTException
# 
# <tt><b>since</b></tt> UES8-23
  def self.create(locationUri, personalRole = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    personalRole = Ues::Core::Personalrole::UESPersonalRoleCreate.new(personalRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.create(locationUri, personalRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command returns attributes representing the personalRole specified by the personalRoleURI parameter. The command does not change the state of the
# personalRole in the system.
# 
# <tt><b>param</b></tt> personalRoleURI UESURI of a personalRole whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the personalRole attributes
# 
# <tt><b>throws</b></tt> UESPersonalRoleRTException
# 
# <tt><b>since</b></tt> UES8-23
  def self.getAttributes(personalRoleURI)
    personalRoleURI = Ues::Core::Commons::Uri::UESURI.new(personalRoleURI).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.getAttributes(personalRoleURI)
    if (_r != nil) then _r = Ues::Core::Personalrole::UESPersonalRoleAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Personalrole::UESPersonalRole
    alias attributes getAttributes
  end

# Command for setting Access Codes of an personalRole.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of the Personal Role whose access codes are to be changed
# 
# <tt><b>param</b></tt> setAccessCodes UESPersonalRoleSetAccessCodes DTO containing new Access Code 1 and 2.
# 
# <tt><b>return</b></tt> UESURI of the PersonalRole
# 
# <tt><b>throws</b></tt> UESPersonalRoleRTException
# 
# <tt><b>since</b></tt> UES8-23
  def self.setAccessCodes(personalRoleUri, setAccessCodes = nil)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    setAccessCodes = Ues::Core::Personalrole::UESPersonalRoleSetAccessCodes.new(setAccessCodes).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.setAccessCodes(personalRoleUri, setAccessCodes)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Personalrole::UESPersonalRole
    alias set_access_codes setAccessCodes
  end

  # :stopdoc:
  def self.setAccesCodes(personalRoleUri, setAccessCodes = nil)
    warn "[DEPRECATED: Ues::Core::Personalrole::UESPersonalRole.setAccesCodes] Use #setAccessCodes() instead."
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    setAccessCodes = Ues::Core::Personalrole::UESPersonalRoleSetAccessCodes.new(setAccessCodes).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.setAccesCodes(personalRoleUri, setAccessCodes)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Personalrole::UESPersonalRole
    alias set_acces_codes setAccesCodes
  end
  # :startdoc:

# This command returns a list of territories the personal role has access to.
# The command does not return all territories, only a sublist. The list of
# returned territories can be filtered by the name, code or type of an
# territory. The list is sorted by names (and codes in case two names are
# equal) by default, or it can be sorted arbitrarily.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of the personal role whose territories are
# listed.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing territories. Available
# parameters are: UESTerritoryAttributes#name name,
# UESTerritoryAttributes#code code,
# UESTerritoryAttributes#preferred preferred and
# UESTerritoryAttributes#type type :
# UESTerritoryType UESTerritoryType.
# 
# <tt><b>see</b></tt> <a
# href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY"
# target="_blank">UESQuery Documentation.</a>
# 
# <tt><b>return</b></tt> List of DTO representing territories.
# 
# <tt><b>throws</b></tt> UESPersonalRoleRTException
# 
# <tt><b>since</b></tt> UES6-06
  def self.getTerritoryList(personalRoleUri, criteria = nil)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    criteria = Ues::Core::Personalrole::UESPersonalRoleGetTerritoryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.getTerritoryList(personalRoleUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Personalrole::UESPersonalRole
    alias territory_list getTerritoryList
  end

# This command returns profile information of the user.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of the personal role whose profile attributes
# are returned.
# 
# <tt><b>return</b></tt> DTO representing user's profile data.
# 
# <tt><b>throws</b></tt> UESPersonalRoleRTException
# 
# <tt><b>since</b></tt> UES6-06
  def self.getProfileAttributes(personalRoleUri)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.getProfileAttributes(personalRoleUri)
    if (_r != nil) then _r = Ues::Core::Personalrole::UESProfileAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Personalrole::UESPersonalRole
    alias profile_attributes getProfileAttributes
  end

# Sets user's profile attributes.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of the personal role which represents the
# user and for which the language settings are modified. Never null.
# 
# <tt><b>param</b></tt> profile Object containing personal profile attributes, contained
# language can be null.
# 
# <tt><b>return</b></tt> Returns UESURI of the personal role, for which was the language
# settings modified.
# 
# <tt><b>throws</b></tt> UESPersonalRoleRTException
# 
# <tt><b>since</b></tt> UES8-07
  def self.setProfileAttributes(personalRoleUri, profile = nil)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    profile = Ues::Core::Personalrole::UESProfileSetAttributes.new(profile).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.setProfileAttributes(personalRoleUri, profile)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Personalrole::UESPersonalRole
    alias set_profile_attributes setProfileAttributes
  end

# Configures user settings of artifact presentation. User will see artifacts
# according to this configuration. Presentation of artifact can be affected
# by these attributes: artifact width, header mode (two lines, one line,
# none), control bar visibility, artifact header sticking, context menu mode
# (advanced, simple). When viewing an artifact, presentation settings are
# looked up in the following order: User settings, artifact presentation
# settings, meta artifact template presentation settings, and layout
# artifact, if it is configured, or default system settings otherwise.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of the personal role whose profile attributes
# are to be configured.
# 
# <tt><b>param</b></tt> attributes DTO of presentation attributes
# 
# <tt><b>throws</b></tt> UESPersonalRoleRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.setArtifactPresentationAttributes(personalRoleUri, attributes = nil)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    attributes = Ues::Core::Personalrole::UESPersonalRoleSetArtifactPresentationAttributes.new(attributes).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.setArtifactPresentationAttributes(personalRoleUri, attributes)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Personalrole::UESPersonalRole
    alias set_artifact_presentation_attributes setArtifactPresentationAttributes
  end

# Retrieves user settings of artifact presentation. User will see artifacts
# according to this configuration. Presentation of artifact can be affected
# by these attributes: artifact width, header mode (two lines, one line,
# none), control bar visibility, artifact header sticking, context menu mode
# (advanced, simple). When viewing an artifact, presentation settings are
# looked up in the following order: User settings, artifact presentation
# settings, meta artifact template presentation settings, and layout
# artifact, if it is configured, or default system settings otherwise.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of the personal role whose profile attributes
# are to be retrieved.
# 
# <tt><b>return</b></tt> UESPersonalRoleArtifactPresentationAttributes DTO of user settings
# of artifact presentation
# 
# <tt><b>throws</b></tt> UESPersonalRoleRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.getArtifactPresentationAttributes(personalRoleUri)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.getArtifactPresentationAttributes(personalRoleUri)
    if (_r != nil) then _r = Ues::Core::Personalrole::UESPersonalRoleArtifactPresentationAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Personalrole::UESPersonalRole
    alias artifact_presentation_attributes getArtifactPresentationAttributes
  end

# Relocates a Personal Role between two territories within the same Territory Container.
# It is not possible to relocate a Personal Role within the same territory or across Territory Containers.
# To relocate a Personal Role, it is necessary to have permissions to move the selected Personal Role and
# insert it into the selected location according to the selected meta artifact. Note that attributes related
# to authorization and structure are not preserved when relocating the Personal Role and their value is evaluated
# the same way as when creating a new Personal Role.
# 
# <tt><b>param</b></tt> personalRoleUri UESURI of a Personal Role to relocate.
# 
# <tt><b>param</b></tt> personalRole Object containing a new location and modified attributes of the Personal Role.
# 
# <tt><b>return</b></tt> UU::OS::UESURI - UESURI of the relocated Personal Role.
# 
# <tt><b>throws</b></tt> UESPersonalRoleRTException, UESArtifactRTException
# 
# <tt><b>since</b></tt> UES8-23
  def self.relocate(personalRoleUri, personalRole = nil)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    personalRole = Ues::Core::Personalrole::UESPersonalRoleRelocate.new(personalRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.relocate(personalRoleUri, personalRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Returns list of accounts for an user.
# 
# <tt><b>param</b></tt> personalRoleUri identifies the user for which are accounts retrieved
# 
# <tt><b>return</b></tt> list of accounts
# 
# <tt><b>throws</b></tt> UESPersonalRoleRTException if the personalRoleUri parameter is either <code>null</code>
# 
# <tt><b>since</b></tt> UES8-23
  def self.getAccountList(personalRoleUri)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.getAccountList(personalRoleUri)
    if (_r != nil) then _t = []; _r.to_a.each do |_e|; if (_e != nil) then _e = Ues::Core::Personalrole::UESPersonalRoleAccountAttributes.new(_e) end; _t << _e; end; _r = _t; end;
    return _r
  end
  class << Ues::Core::Personalrole::UESPersonalRole
    alias account_list getAccountList
  end

# Removes account.
# 
# <tt><b>param</b></tt> personalRoleUri identifies the user for which is the account removed
# 
# <tt><b>param</b></tt> attributes this parameter specifies the account to be deleted
# 
# <tt><b>throws</b></tt> UESPersonalRoleRTException if the personalRoleUri parameter is either <code>null</code>
# or there is no account which conforms to constraints specified in attributes parameter
# 
# <tt><b>since</b></tt> UES8-23
  def self.removeAccount(personalRoleUri, attributes = nil)
    personalRoleUri = Ues::Core::Commons::Uri::UESURI.new(personalRoleUri).to_java
    attributes = Ues::Core::Personalrole::UESPersonalRoleRemoveAccount.new(attributes).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.personalrole.UESPersonalRole.java_class)
    _r = _s.removeAccount(personalRoleUri, attributes)
    
    return _r
  end
  class << Ues::Core::Personalrole::UESPersonalRole
    alias remove_account removeAccount
  end
end
