extClass=Ues::Core::Personalrole::UESPersonalRole


# User language. The language is in the ISO 639-1 format, for example: en, cs, es, ru, sk. Never null.
#
# This UES API functionality is provided only in ruby language. Use command getProfileAttributes on
# UESPersonalRole in java or when accessing UES API directly via web services.
# <tt><b>since</b></tt> UES6-06
def extClass.getLanguage
  self.getProfileAttributes(UESSession.getPersonalRole()).getLanguage()
end

# Normalized UESURI of the territory the personal role is contained in. Never null.
#
# This UES API functionality is provided only in ruby language. Use command getProfileAttributes on
# UESPersonalRole in java or when accessing UES API directly via web services.
# <tt><b>since</b></tt> UES6-06
def extClass.getMyTerritory
  self.getProfileAttributes(UESSession.getPersonalRole()).getMyTerritoryUri()
end

# Normalized UESURI of the personal role. Never null.
#
# This UES API functionality is provided only in ruby language. Use command getProfileAttributes on
# UESPersonalRole in java or when accessing UES API directly via web services.
# <tt><b>since</b></tt> UES6-06
def extClass.getMyRole
  self.getProfileAttributes(UESSession.getPersonalRole()).getMyRoleUri()
end

# Normalized UESURI of the personal role's artifact. Never null.
#
# This UES API functionality is provided only in ruby language. Use command getProfileAttributes on
# UESPersonalRole in java or when accessing UES API directly via web services.
# <tt><b>since</b></tt> UES6-06
def extClass.getMyArtifact
  self.getProfileAttributes(UESSession.getPersonalRole()).getMyArtifactUri()
end

# Normalized UESURI of the personal role's workspace folder. Never null.
#
# This UES API functionality is provided only in ruby language. Use command getProfileAttributes on
# UESPersonalRole in java or when accessing UES API directly via web services.
# <tt><b>since</b></tt> UES6-06
def extClass.getMyWorkspace
  self.getProfileAttributes(UESSession.getPersonalRole()).getMyWorkspaceUri()
end

# Normalized UESURI of the preferred territory. It is the preferred territory of the user identified by the personal role. Null when no
# preferred territory is set for the personal role.
#
# This UES API functionality is provided only in ruby language. Use command getProfileAttributes on
# UESPersonalRole in java or when accessing UES API directly via web services.
# <tt><b>since</b></tt> UES6-06
def extClass.getPreferredTerritory
  self.getProfileAttributes(UESSession.getPersonalRole()).getPreferredTerritoryUri()
end

# Normalized UESURI of the access role in the preferred territory. It is the access role of the user identified by the personal role.
# Null when no preferred territory is set for the personal role.
#
# This UES API functionality is provided only in ruby language. Use command getProfileAttributes on
# UESPersonalRole in java or when accessing UES API directly via web services.
# <tt><b>since</b></tt> UES6-06
def extClass.getPreferredAccessRole
  self.getProfileAttributes(UESSession.getPersonalRole()).getPreferredAccessRoleUri()
end

# Normalized UESURI of the preferred role in the preferred territory. Those are the preferred territory and the preferred role of the
# user identified by the personal role. Null when no preferred territory is set for the personal role or no preferred role is set in the
# territory.
#
# This UES API functionality is provided only in ruby language. Use command getProfileAttributes on
# UESPersonalRole in java or when accessing UES API directly via web services.
# <tt><b>since</b></tt> UES6-06
def extClass.getPreferredRole
  self.getProfileAttributes(UESSession.getPersonalRole()).getPreferredRoleUri()
end

# Normalized UESURI of the preferred role's artifact in the preferred territory. Those are the preferred territory and the preferred role
# of the user identified by the personal role. Null when no preferred territory is set for the personal role or no preferred role is set
# in the territory.
#
# This UES API functionality is provided only in ruby language. Use command getProfileAttributes on
# UESPersonalRole in java or when accessing UES API directly via web services.
# <tt><b>since</b></tt> UES6-06
def extClass.getPreferredArtifact
  self.getProfileAttributes(UESSession.getPersonalRole()).getPreferredArtifactUri()
end

# Normalized UESURI of the preferred role's workspace folder in the preferred territory. Those are the preferred territory and the
# preferred role of the user identified by the personal role. Null when no preferred territory is set for the personal role or no
# preferred role is set in the territory.
#
# This UES API functionality is provided only in ruby language. Use command getProfileAttributes on
# UESPersonalRole in java or when accessing UES API directly via web services.
# <tt><b>since</b></tt> UES6-06
def extClass.getPreferredWorkspace
  self.getProfileAttributes(UESSession.getPersonalRole()).getPreferredWorkspaceUri()
end
  