#--
# This code is automatically generated, do not modify the content !!!
#++
# UESProcess component allows access to process associated with current use case. Its purpose is to offer methods for reporting progress
# and for synchronization with other processes launched from current use case.
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
class Ues::Core::Process::UESProcess
  private_class_method :new


# Method used to configure propagation of process events to activity from which was process launched.
# 
# <tt><b>param</b></tt> enabled true/false
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
  def self.setProcessEventToActivityPropagationEnabled(enabled)
    
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.setProcessEventToActivityPropagationEnabled(enabled)
    
    return _r
  end
  class << Ues::Core::Process::UESProcess
    alias process_event_to_activity_propagation_enabled= setProcessEventToActivityPropagationEnabled
  end

# Method used to read configuration of propagation of process events to activity from which was process launched.
# 
# <tt><b>return</b></tt> True if propagation is enabled, else false
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-04
  def self.isProcessEventToActivityPropagationEnabled()
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.isProcessEventToActivityPropagationEnabled()
    
    return _r
  end
  class << Ues::Core::Process::UESProcess
    alias process_event_to_activity_propagation_enabled? isProcessEventToActivityPropagationEnabled
  end

# Method should be called on the beginning of use case. It allows to set custom message to be send to user and also set total steps
# needed to be worked in use case. Calling of this method is optional as long as we do not want to report use case progress using
# progress bar dialog.
# 
# <tt><b>param</b></tt> message Message for user (may be null)
# 
# <tt><b>param</b></tt> totalSteps Total steps to be done
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
  def self.start(message, totalSteps = nil)
    message = Ues::Platform::Process::UESMessage.new(message).to_java
    
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.start(message, totalSteps)
    
    return _r
  end

# Method send info notification from use case. Unlike common messages (send by progress method) which is stored directly on recent
# process, notification is propagated further into other components and may trigger additional actions. Therefore notification should be
# used only for reporting of important milestones in use case flow. 
# In case detailed reporting was enabled (totalSteps were set in start method), each call of info notification means one step.
# 
# <tt><b>param</b></tt> message Message for user
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
  def self.info(message)
    message = Ues::Platform::Process::UESMessage.new(message).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.info(message)
    
    return _r
  end

# Method send warning notification from use case. Unlike common messages (send by progress method) which is stored directly on recent
# process, notification is propagated further into other components and may trigger additional actions. Therefore warning notification
# should be used only for reporting of more serious problems milestones in use case flow. 
# In case detailed reporting was enabled (totalSteps were set in start method), call of warning notification has no effect (progress is
# not pushed further).
# 
# <tt><b>param</b></tt> message Message for user
# 
# <tt><b>param</b></tt> exception Exception which caused problem (may be null)
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
  def self.warning(message, exception = nil)
    message = Ues::Platform::Process::UESMessage.new(message).to_java
    if (exception.java_kind_of?NativeException) then exception = exception.cause elsif (exception.java_kind_of?Exception) then; _t = []; begin exception.backtrace.each do |_e|; _p = _e.split(":"); _t.push(Java::java.lang.StackTraceElement.new(_p[0], "", _p[2], Integer(_p[1]))); end; rescue; end; exception = Java::java.lang.Exception.new(exception.message); exception.setStackTrace(_t.to_java(Java::java.lang.StackTraceElement)); end;
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.warning(message, exception)
    
    return _r
  end

# Method is used for informing user of use case progress. Unlike notifications, progress message is stored directly on process and is not
# propagated into other components. 
# In case detailed reporting was enabled (totalSteps were set in start method), each call of progress method means one step.
# 
# <tt><b>param</b></tt> message Message for user (may be null)
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
  def self.progress(message)
    message = Ues::Platform::Process::UESMessage.new(message).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.progress(message)
    
    return _r
  end

# Method is used for invocation of general active process event (alternative to using methods info, warning and progress). Unlike other
# methods, general event has more options. It allows to set code of event (which may be used by other processes as synchronization point)
# and UESURI of related object (used to provide partial result for processes waiting for this event).
# 
# <tt><b>param</b></tt> processEvent UESProcessEvent DTO
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
  def self.fireActiveEvent(processEvent)
    processEvent = Ues::Core::Process::UESProcessEvent.new(processEvent).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.fireActiveEvent(processEvent)
    
    return _r
  end
  class << Ues::Core::Process::UESProcess
    alias fire_active_event fireActiveEvent
  end

# Method marks use case as completed. This state means use case is finished and activity will end in non-final sate. 
# Calling of this method is optional.
# 
# <tt><b>param</b></tt> message Message for user (may be null)
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
  def self.completed(message)
    message = Ues::Platform::Process::UESMessage.new(message).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.completed(message)
    
    return _r
  end

# Method marks use case as completed with warnings. This state means use case is finished but due to some internal problems it did not
# provide expected result but ended up in some alternative flow. 
# Calling of this method is optional.
# 
# <tt><b>param</b></tt> message Message for user (may be null)
# 
# <tt><b>param</b></tt> exception Instance of exception caused warning (may be null)
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
  def self.completedWithWarning(message, exception = nil)
    message = Ues::Platform::Process::UESMessage.new(message).to_java
    if (exception.java_kind_of?NativeException) then exception = exception.cause elsif (exception.java_kind_of?Exception) then; _t = []; begin exception.backtrace.each do |_e|; _p = _e.split(":"); _t.push(Java::java.lang.StackTraceElement.new(_p[0], "", _p[2], Integer(_p[1]))); end; rescue; end; exception = Java::java.lang.Exception.new(exception.message); exception.setStackTrace(_t.to_java(Java::java.lang.StackTraceElement)); end;
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.completedWithWarning(message, exception)
    
    return _r
  end
  class << Ues::Core::Process::UESProcess
    alias completed_with_warning completedWithWarning
  end

# Method marks use case as failed. Failed state means there was some serious problem which is not covered by any alternative flow of use
# case. 
# Calling of this method is optional. In case of exception thrown from use case, process automatically ends in failed state. This method
# can be uses to override default error message.
# 
# <tt><b>param</b></tt> message Message for user (may be null)
# 
# <tt><b>param</b></tt> exception Instance of exception caused error (may be null)
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
  def self.completedWithError(message, exception = nil)
    message = Ues::Platform::Process::UESMessage.new(message).to_java
    if (exception.java_kind_of?NativeException) then exception = exception.cause elsif (exception.java_kind_of?Exception) then; _t = []; begin exception.backtrace.each do |_e|; _p = _e.split(":"); _t.push(Java::java.lang.StackTraceElement.new(_p[0], "", _p[2], Integer(_p[1]))); end; rescue; end; exception = Java::java.lang.Exception.new(exception.message); exception.setStackTrace(_t.to_java(Java::java.lang.StackTraceElement)); end;
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.completedWithError(message, exception)
    
    return _r
  end
  class << Ues::Core::Process::UESProcess
    alias completed_with_error completedWithError
  end

# Method marks use case as finished. This state means use case is finished and activity will end in final sate. Calling of this method is
# optional.
# 
# <tt><b>param</b></tt> message Message for user (may be null)
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
  def self.completedFinal(message)
    message = Ues::Platform::Process::UESMessage.new(message).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.completedFinal(message)
    
    return _r
  end
  class << Ues::Core::Process::UESProcess
    alias completed_final completedFinal
  end

# Method is used for invocation of general completed process event (alternative to using methods completed, completedWithWarning,
# completedWithError and completedFinal). Unlike other methods, general event has more options. It allows to set code of event (which may
# be used by other processes as synchronization point) and UESURI of related object (used to provide partial result for processes waiting
# for this event).
# 
# <tt><b>param</b></tt> processEvent UESProcessEvent DTO
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
  def self.fireCompletedEvent(processEvent)
    processEvent = Ues::Core::Process::UESProcessEvent.new(processEvent).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.fireCompletedEvent(processEvent)
    
    return _r
  end
  class << Ues::Core::Process::UESProcess
    alias fire_completed_event fireCompletedEvent
  end

# Method searches all subprocesses of recent use case process and returns first result matching provided event codes within given
# timeout. In case no event codes are given, method waits until all subprocesses are finished and returns result with UESURI of related
# object from last finished process (result which was set in last finished subprocess, if non is present, result from previously finished
# subprocess, etc.)null is immediately returned. 
# Method waits for result until matching event is invoked from any subprocess, timeout expires or all subprocesses are finished (meaning
# expected event cannot be set anymore).
# 
# <tt><b>param</b></tt> timeout Timeout in milliseconds (0 for maximum (8 hours) timeout, negative value for returning immediate result).
# 
# <tt><b>param</b></tt> eventCodes List of event codes (regular expressions may be used)
# 
# <tt><b>return</b></tt> First found result matching event codes or last result from all subprocesses if event codes are not provided.
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-02
  def self.getResult(timeout, *eventCodes)
    
    if (eventCodes.size == 1) then begin eventCodes = eventCodes[0].to_a; rescue; end; end;
    if (eventCodes != nil) then _t = []; eventCodes.to_a.each do |_e|; if ((!_e.java_kind_of?Java::java.lang.Object) && (_e.class.method_defined?"to_java")) then _e = _e.to_java end; _t << _e; end; eventCodes = _t.to_java(Java::java.lang.String); end;
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.getResult(timeout, eventCodes)
    if (_r != nil) then _r = Ues::Platform::Process::UESProcessResult.new(_r) end
    return _r
  end
  class << Ues::Core::Process::UESProcess
    alias result getResult
  end

# Returns UESURI of currently active process or null if there is no active process.
# 
# <tt><b>return</b></tt> UESURI of process
# 
# <tt><b>author</b></tt> 5-8084-1
# 
# <tt><b>since</b></tt> UES8-08
  def self.getCurrentProcessUri()
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.process.UESProcess.java_class)
    _r = _s.getCurrentProcessUri()
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Process::UESProcess
    alias current_process_uri getCurrentProcessUri
  end
end
