#--
# This code is automatically generated, do not modify the content !!!
#++
# The QoS service is used for setting and getting a QoS limits for the access roles or territory.
# 
# <tt><b>since</b></tt> UES8-08
class Ues::Core::Qos::UESQoS
  private_class_method :new


# Returns a DTO representing QoS for a specific territory. The values represents a requests limit per particular period. Special values
# are 0 (no request is allowed) and -1 (unlimited).
# 
# <tt><b>param</b></tt> territoryUri UESURI of the territory for which QoS will be returned.
# 
# <tt><b>return</b></tt> DTO with an actual QoS setting for a territory, provided by the territoryUri parameter.
# 
# <tt><b>throws</b></tt> UESQoSRTException
# 
# <tt><b>since</b></tt> UES8-08
  def self.getTerritoryQoS(territoryUri)
    territoryUri = Ues::Core::Commons::Uri::UESURI.new(territoryUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.qos.UESQoS.java_class)
    _r = _s.getTerritoryQoS(territoryUri)
    if (_r != nil) then _r = Ues::Core::Qos::UESTerritoryGetQoS.new(_r) end
    return _r
  end
  class << Ues::Core::Qos::UESQoS
    alias territory_qo_s getTerritoryQoS
  end

# Sets QoS for a specific territory. You must specify at least one value from UESTerritorySetQoS DTO provided as parameter
# 'setQoS'. If you don't define some values in the DTO so they stay untouched for existing QoS limits. If no QoS exists for the
# territory, than new one is created and undefined parameters in DTO are set to -1 (unlimited).
# 
# <tt><b>param</b></tt> territoryUri UESURI of a territory for which a QoS is to be set.
# 
# <tt><b>param</b></tt> setQoS DTO containing attributes for setting QoS.
# 
# <tt><b>throws</b></tt> UESQoSRTException
# 
# <tt><b>since</b></tt> UES8-08
  def self.setTerritoryQoS(territoryUri, setQoS = nil)
    territoryUri = Ues::Core::Commons::Uri::UESURI.new(territoryUri).to_java
    setQoS = Ues::Core::Qos::UESTerritorySetQoS.new(setQoS).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.qos.UESQoS.java_class)
    _r = _s.setTerritoryQoS(territoryUri, setQoS)
    
    return _r
  end
  class << Ues::Core::Qos::UESQoS
    alias set_territory_qo_s setTerritoryQoS
  end

# Returns a DTO representing QoS for a specific access role. The values represents a requests limit per particular period. Special values
# are 0 (no request is allowed) and -1 (unlimited).
# 
# <tt><b>param</b></tt> accessRoleUri UESURI of the access role for which QoS will be returned.
# 
# <tt><b>return</b></tt> DTO with an actual QoS setting for an access role, provided by the accessRoleUri parameter.
# 
# <tt><b>throws</b></tt> UESQoSRTException
# 
# <tt><b>since</b></tt> UES8-08
  def self.getAccessRoleQoS(accessRoleUri)
    accessRoleUri = Ues::Core::Commons::Uri::UESURI.new(accessRoleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.qos.UESQoS.java_class)
    _r = _s.getAccessRoleQoS(accessRoleUri)
    if (_r != nil) then _r = Ues::Core::Qos::UESAccessRoleGetQoS.new(_r) end
    return _r
  end
  class << Ues::Core::Qos::UESQoS
    alias access_role_qo_s getAccessRoleQoS
  end

# Sets QoS for a specific access role. You must specify at least one value from UESAccessRoleSetQoS DTO provided as parameter
# 'setQoS'. If you don't define some values in the DTO, so they stay untouched for existing QoS limits. If no QoS exists for the access
# role, than new one is created and undefined parameters in DTO are set to -1 (unlimited).
# 
# <tt><b>param</b></tt> accessRoleUri UESURI of a access role for which QoS is to be set.
# 
# <tt><b>param</b></tt> setQoS Object containing attributes for setting QoS.
# 
# <tt><b>throws</b></tt> UESQoSRTException
# 
# <tt><b>since</b></tt> UES8-08
  def self.setAccessRoleQoS(accessRoleUri, setQoS = nil)
    accessRoleUri = Ues::Core::Commons::Uri::UESURI.new(accessRoleUri).to_java
    setQoS = Ues::Core::Qos::UESAccessRoleSetQoS.new(setQoS).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.qos.UESQoS.java_class)
    _r = _s.setAccessRoleQoS(accessRoleUri, setQoS)
    
    return _r
  end
  class << Ues::Core::Qos::UESQoS
    alias set_access_role_qo_s setAccessRoleQoS
  end
end
