#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES7-10
class Ues::Core::Role::UESAccessRole
  private_class_method :new

  BEACCESSROLE_CODE = Java::cz.ues.core.role.UESAccessRole::BEACCESSROLE_CODE #:nodoc:

  # URI of access role business entity.
# 
# <tt><b>since</b></tt> UES7-10
  BETYPE_ACCESSROLE = Java::cz.ues.core.role.UESAccessRole::BETYPE_ACCESSROLE


# This command returns attributes representing the personal access role specified by the accessRoleUri parameter. The command does not
# change the state of the role in the system.
# 
# <tt><b>param</b></tt> accessRoleUri UESURI of a personal access role whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the personal access role attributes
# 
# <tt><b>throws</b></tt> UESAccessRoleRTException
  def self.getAttributes(accessRoleUri)
    accessRoleUri = Ues::Core::Commons::Uri::UESURI.new(accessRoleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESAccessRole.java_class)
    _r = _s.getAttributes(accessRoleUri)
    if (_r != nil) then _r = Ues::Core::Role::UESAccessRoleAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESAccessRole
    alias attributes getAttributes
  end

# Command for setting attributes of an access role. The command can't modify references to objects like location, competent role and so
# on.
# 
# <tt><b>param</b></tt> accessRoleUri UESURI of the access role whose attributes are to be changed
# 
# <tt><b>param</b></tt> accessRole DTO containing new attributes the access role
# 
# <tt><b>return</b></tt> UESURI of the access role
# 
# <tt><b>throws</b></tt> UESAccessRoleRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.setAttributes(accessRoleUri, accessRole = nil)
    accessRoleUri = Ues::Core::Commons::Uri::UESURI.new(accessRoleUri).to_java
    accessRole = Ues::Core::Role::UESAccessRoleSetAttributes.new(accessRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESAccessRole.java_class)
    _r = _s.setAttributes(accessRoleUri, accessRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESAccessRole
    alias set_attributes setAttributes
  end

# Creates a new access role. The command creates a new access role in a specified location. At the very least meta artifact must be
# specified in UESAccessRoleCreate DTO. Competent role for the new role will be selected as the most suitable according to the
# specified container and meta artifact (executive/authorized role with connected interface), or can be also specified in
# UESAccessRoleCreate DTO.
# 
# <tt><b>param</b></tt> locationUri UESURI of the folder/org. unit/meta model where the access role will be created.
# 
# <tt><b>param</b></tt> DTO containing attributes of the new access role
# 
# <tt><b>return</b></tt> UESURI of the new access role
# 
# <tt><b>throws</b></tt> UESAccessRoleRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.create(locationUri, accessRole = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    accessRole = Ues::Core::Role::UESAccessRoleCreate.new(accessRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESAccessRole.java_class)
    _r = _s.create(locationUri, accessRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# Returns list of the role interfaces that are connected to the specified access role. The list of returned interfaces could be filtered
# by the name or code. Returned list does not contain any objects filtered out by executed UESQuery. The list is sorted by the name (and
# by code in case are equal) of an interface by default.
# 
# <tt><b>param</b></tt> accessRoleUri UESURI of the access role for which the connected role interfaces are to be listed
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing access role interfaces. Available parameters are:
# cz.ues.core.role.dto.UESAccessRoleGetRoleInterfaceListItem#name name and
# cz.ues.core.role.dto.UESAccessRoleGetRoleInterfaceListItem#code code
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List of DTO representing role interfaces which are connected to the specified access role
# 
# <tt><b>throws</b></tt> UESAccessRoleRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getRoleInterfaceList(accessRoleUri, criteria = nil)
    accessRoleUri = Ues::Core::Commons::Uri::UESURI.new(accessRoleUri).to_java
    criteria = Ues::Core::Role::UESAccessRoleGetRoleInterfaceList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESAccessRole.java_class)
    _r = _s.getRoleInterfaceList(accessRoleUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESAccessRole
    alias role_interface_list getRoleInterfaceList
  end

# The command removes role interface connection from the specified access role. Only connected interfaces can be disconnected from the
# access role.
# 
# <tt><b>param</b></tt> accessRoleUri UESURI of the access role where the role interface will be disconnected
# 
# <tt><b>param</b></tt> roleInterface DTO containing role interface that to be disconnected
# 
# <tt><b>throws</b></tt> UESAccessRoleRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.removeRoleInterface(accessRoleUri, roleInterface = nil)
    accessRoleUri = Ues::Core::Commons::Uri::UESURI.new(accessRoleUri).to_java
    roleInterface = Ues::Core::Role::UESAccessRoleRemoveRoleInterface.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESAccessRole.java_class)
    _r = _s.removeRoleInterface(accessRoleUri, roleInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESAccessRole
    alias remove_role_interface removeRoleInterface
  end

# This command creates new role interface connection to the specified access role. The role interface has to be in an active state and
# mustn't be already connected. The role interface has to be connected to the one of the authorized roles for this command, or the
# authorized role has to be casted to the default group of meta model where the role interface is located.
# 
# <tt><b>param</b></tt> accessRoleUri UESURI of the access role where the role interface will be connected
# 
# <tt><b>param</b></tt> roleInterface DTO containing role interface that to be connected
# 
# <tt><b>throws</b></tt> UESAccessRoleRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.addRoleInterface(accessRoleUri, roleInterface = nil)
    accessRoleUri = Ues::Core::Commons::Uri::UESURI.new(accessRoleUri).to_java
    roleInterface = Ues::Core::Role::UESAccessRoleAddRoleInterface.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESAccessRole.java_class)
    _r = _s.addRoleInterface(accessRoleUri, roleInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESAccessRole
    alias add_role_interface addRoleInterface
  end

# Returns list of personal access roles in the given location with specified criteria.
# 
# <tt><b>param</b></tt> territoryUri Never null. UESURI of the territory, from which the access roles will be retrieved.
# 
# <tt><b>param</b></tt> criteria Object containing paging and filtering criteria.
# 
# <tt><b>return</b></tt> List of personal access roles in the territory. Contains instances of cz.ues.core.role.dto.UESAccessRoleAttributes.
# 
# <tt><b>throws</b></tt> UESAccessRoleRTException
# 
# <tt><b>since</b></tt> UES8-08
  def self.getAccessRoleList(territoryUri, criteria = nil)
    territoryUri = Ues::Core::Commons::Uri::UESURI.new(territoryUri).to_java
    criteria = Ues::Core::Role::UESAccessRoleGetList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESAccessRole.java_class)
    _r = _s.getAccessRoleList(territoryUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESAccessRole
    alias access_role_list getAccessRoleList
  end

# This command deactivates an access role. The access role will lose access to its territory.
# 
# <tt><b>param</b></tt> accessRoleUri UESURI of an access role that the access will be canceled.
# 
# <tt><b>throws</b></tt> UESAccessRoleRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.deactivateAccess(accessRoleUri)
    accessRoleUri = Ues::Core::Commons::Uri::UESURI.new(accessRoleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESAccessRole.java_class)
    _r = _s.deactivateAccess(accessRoleUri)
    
    return _r
  end
  class << Ues::Core::Role::UESAccessRole
    alias deactivate_access deactivateAccess
  end

# This command activates an access role. The access role will have access to its territory.
# 
# <tt><b>param</b></tt> accessRoleUri UESURI of an access role that the access will be reactivated.
# 
# <tt><b>throws</b></tt> UESAccessRoleRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.activateAccess(accessRoleUri)
    accessRoleUri = Ues::Core::Commons::Uri::UESURI.new(accessRoleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESAccessRole.java_class)
    _r = _s.activateAccess(accessRoleUri)
    
    return _r
  end
  class << Ues::Core::Role::UESAccessRole
    alias activate_access activateAccess
  end
end
