#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES6-10
class Ues::Core::Role::UESGroup
  private_class_method :new

  BEGROUP_CODE = Java::cz.ues.core.role.UESGroup::BEGROUP_CODE #:nodoc:

  # URI of group business entity.
# 
# <tt><b>since</b></tt> UES6-10
  BETYPE_GROUP = Java::cz.ues.core.role.UESGroup::BETYPE_GROUP


# Creates a new group role. The command creates a new group in a specified location. At the very least meta artifact must be specified in
# UESGroupCreate DTO. Competent role for the new group will be selected as the most suitable according to specified container and
# meta artifact (executive/authorized role with connected interface), or can be also specified in UESGroupCreate DTO.
# 
# <tt><b>param</b></tt> locationUri locationUri UESURI of the folder/org. unit/meta model where the group will be created.
# 
# <tt><b>param</b></tt> role DTO containing attributes of the new group
# 
# <tt><b>return</b></tt> UESURI of the new group
# 
# <tt><b>throws</b></tt> UESGroupRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.create(locationUri, group = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    group = Ues::Core::Role::UESGroupCreate.new(group).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESGroup.java_class)
    _r = _s.create(locationUri, group)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command returns attributes representing the group role specified by the groupRoleUri parameter. The command does not change the
# state of the group in the system.
# 
# <tt><b>param</b></tt> groupUri UESURI of a group whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the group attributes
# 
# <tt><b>throws</b></tt> UESGroupRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.getAttributes(groupUri)
    groupUri = Ues::Core::Commons::Uri::UESURI.new(groupUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESGroup.java_class)
    _r = _s.getAttributes(groupUri)
    if (_r != nil) then _r = Ues::Core::Role::UESGroupAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESGroup
    alias attributes getAttributes
  end

# Command for setting attributes of a group role. The command can't modify references to objects like location, competent role and so on.
# 
# <tt><b>param</b></tt> groupUri UESURI of the group whose attributes are to be changed
# 
# <tt><b>param</b></tt> group DTO containing new attributes the group
# 
# <tt><b>return</b></tt> UESURI of the group
# 
# <tt><b>throws</b></tt> UESGroupRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.setAttributes(groupUri, group = nil)
    groupUri = Ues::Core::Commons::Uri::UESURI.new(groupUri).to_java
    group = Ues::Core::Role::UESGroupSetAttributes.new(group).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESGroup.java_class)
    _r = _s.setAttributes(groupUri, group)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESGroup
    alias set_attributes setAttributes
  end

# This command deletes the specified group role from the system. The group is deleted even if it contains a locked sheet or attachment.
# The group cannot be deleted when:
# 
# 
# * the group is not in an active cast.
# 
# * the group's workflow is not created
# 
# * a property contains a reference to this group
# 
# * a time sheet exists with a reference to this group
# 
# * an activity exists with this role as competent role
# 
# 
# 
# 
# <tt><b>param</b></tt> groupUri UESURI of the group which is about to be deleted.
# 
# <tt><b>throws</b></tt> UESGroupRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.delete(groupUri)
    groupUri = Ues::Core::Commons::Uri::UESURI.new(groupUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESGroup.java_class)
    _r = _s.delete(groupUri)
    
    return _r
  end

# This command propagates activities of the group to its casted roles or casted groups. Only the active activities are propagated, it
# means that they have a state and the state must not be final.
# 
# <tt><b>param</b></tt> group UESURI of the group which activities will be propagated
# 
# <tt><b>param</b></tt> castedRoles UESURIs of the roles which must be casted into group with groupRoleUri and into which the activities will be
# propagated
# 
# <tt><b>since</b></tt> UES7-04
  def self.propagateActivities(group, castedRoles = nil)
    group = Ues::Core::Commons::Uri::UESURI.new(group).to_java
    castedRoles = Ues::Core::Role::UESGroupPropagateActivities.new(castedRoles).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESGroup.java_class)
    _r = _s.propagateActivities(group, castedRoles)
    
    return _r
  end
  class << Ues::Core::Role::UESGroup
    alias propagate_activities propagateActivities
  end

# This command cancels activities which exist due to group roles for the specified roles.
# 
# <tt><b>param</b></tt> groupRoleUri UESURI of the group role with activities
# 
# <tt><b>param</b></tt> group DTO containing attributes to canceling activities for casted roles
# 
# <tt><b>throws</b></tt> UESGroupRTException
# 
# <tt><b>since</b></tt> UES7-08
  def self.cancelActivities(groupRoleUri, group = nil)
    groupRoleUri = Ues::Core::Commons::Uri::UESURI.new(groupRoleUri).to_java
    group = Ues::Core::Role::UESGroupCancelActivities.new(group).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESGroup.java_class)
    _r = _s.cancelActivities(groupRoleUri, group)
    
    return _r
  end
  class << Ues::Core::Role::UESGroup
    alias cancel_activities cancelActivities
  end

# This command creates new role interface connection to the specified role. The role interface has to be in an active state and mustn't
# be already connected. The role interface has to be connected to the one of the authorized roles for this command, or the authorized
# role has to be casted to the default group of meta model where the role interface is located.
# 
# <tt><b>param</b></tt> groupRoleUri UESURI of the group role where the role interface will be connected
# 
# <tt><b>param</b></tt> roleInterface DTO containing role interface that to be connected
# 
# <tt><b>throws</b></tt> UESGroupRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.addRoleInterface(groupRoleUri, roleInterface = nil)
    groupRoleUri = Ues::Core::Commons::Uri::UESURI.new(groupRoleUri).to_java
    roleInterface = Ues::Core::Role::UESGroupAddRoleInterface.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESGroup.java_class)
    _r = _s.addRoleInterface(groupRoleUri, roleInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESGroup
    alias add_role_interface addRoleInterface
  end

# The command removes role interface connection from the specified group role. Only connected interfaces can be disconnected from the
# group role.
# 
# <tt><b>param</b></tt> groupRoleUri UESURI of the group role where the role interface will be disconnected
# 
# <tt><b>param</b></tt> roleInterface DTO containing role interface that to be disconnected
# 
# <tt><b>throws</b></tt> UESGroupRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.removeRoleInterface(groupRoleUri, roleInterface = nil)
    groupRoleUri = Ues::Core::Commons::Uri::UESURI.new(groupRoleUri).to_java
    roleInterface = Ues::Core::Role::UESGroupRemoveRoleInterface.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESGroup.java_class)
    _r = _s.removeRoleInterface(groupRoleUri, roleInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESGroup
    alias remove_role_interface removeRoleInterface
  end

# Returns list of the role interfaces that are connected to the specified group role. The list of returned interfaces could be filtered
# by the name or code. Returned list does not contain any objects filtered out by executed UESQuery. The list is sorted by the name (and
# by code in case are equal) of an interface by default.
# 
# <tt><b>param</b></tt> groupRoleUri UESURI of the access role for which the connected role interfaces are to be listed
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing access role interfaces. Available parameters are:
# cz.ues.core.role.dto.UESGroupGetRoleInterfaceListItem#name name and
# cz.ues.core.role.dto.UESGroupGetRoleInterfaceListItem#code code
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List of DTO representing role interfaces which are connected to the specified group role
# 
# <tt><b>throws</b></tt> UESGroupRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getRoleInterfaceList(groupRoleUri, criteria = nil)
    groupRoleUri = Ues::Core::Commons::Uri::UESURI.new(groupRoleUri).to_java
    criteria = Ues::Core::Role::UESGroupGetRoleInterfaceList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESGroup.java_class)
    _r = _s.getRoleInterfaceList(groupRoleUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESGroup
    alias role_interface_list getRoleInterfaceList
  end
end
