#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES8-02
class Ues::Core::Role::UESMetaAccessRole
  private_class_method :new

  BEMETAACCESSROLE_CODE = Java::cz.ues.core.role.UESMetaAccessRole::BEMETAACCESSROLE_CODE #:nodoc:

  # URI of meata access role business entity.
# 
# <tt><b>since</b></tt> UES8-02
  BETYPE_ACCESSROLE = Java::cz.ues.core.role.UESMetaAccessRole::BETYPE_ACCESSROLE


# This command returns attributes representing the meta access role role specified by the metaAccessRoleRoleUri parameter. The command
# does not change the state of the meta access role in the system.
# 
# <tt><b>param</b></tt> metaAccessRoleUri UESURI of a meta access role whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the meta access role attributes
# 
# <tt><b>throws</b></tt> UESMetaAccessRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.getAttributes(metaAccessRoleUri)
    metaAccessRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaAccessRoleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaAccessRole.java_class)
    _r = _s.getAttributes(metaAccessRoleUri)
    if (_r != nil) then _r = Ues::Core::Role::UESMetaAccessRoleAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESMetaAccessRole
    alias attributes getAttributes
  end

# Command for setting attributes of a meta access role. The command can't modify references to objects like location, competent access
# role and so on.
# 
# <tt><b>param</b></tt> metaAccessRoleUri UESURI of a meta access role whose attributes shall be modified
# 
# <tt><b>param</b></tt> metaAccessRole DTO containing new attributes of the meta access role
# 
# <tt><b>return</b></tt> UESURI of the meta access role
# 
# <tt><b>throws</b></tt> UESMetaAccessRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.setAttributes(metaAccessRoleUri, metaAccessRole = nil)
    metaAccessRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaAccessRoleUri).to_java
    metaAccessRole = Ues::Core::Role::UESMetaAccessRoleSetAttributes.new(metaAccessRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaAccessRole.java_class)
    _r = _s.setAttributes(metaAccessRoleUri, metaAccessRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESMetaAccessRole
    alias set_attributes setAttributes
  end

# This command creates new role interface connection to the specified meta access role. The role interface has to be in an active state
# and must not be already added. The role interface can be added to meta access role only provided that role interface is located in the
# same, child or parent meta model as meta access role.
# 
# <tt><b>param</b></tt> metaAccessRoleUri UES URI of the meta access role where the role interface will be added
# 
# <tt><b>param</b></tt> roleInterface DTO containing role interface that to be added
# 
# <tt><b>throws</b></tt> UESMetaAccessRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.addRoleInterface(metaAccessRoleUri, roleInterface = nil)
    metaAccessRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaAccessRoleUri).to_java
    roleInterface = Ues::Core::Role::UESMetaAccessRoleAddRoleInterface.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaAccessRole.java_class)
    _r = _s.addRoleInterface(metaAccessRoleUri, roleInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESMetaAccessRole
    alias add_role_interface addRoleInterface
  end

# The command removes role interface connection from the specified meta access role. Only added interfaces can be removed from meta
# access role.
# 
# <tt><b>param</b></tt> metaAccessRoleUri UES URI of the meta access role where the role interface will be removed
# 
# <tt><b>param</b></tt> roleInterface DTO containing role interface that to be removed
# 
# <tt><b>throws</b></tt> UESMetaAccessRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.removeRoleInterface(metaAccessRoleUri, roleInterface = nil)
    metaAccessRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaAccessRoleUri).to_java
    roleInterface = Ues::Core::Role::UESMetaAccessRoleRemoveRoleInterface.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaAccessRole.java_class)
    _r = _s.removeRoleInterface(metaAccessRoleUri, roleInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESMetaAccessRole
    alias remove_role_interface removeRoleInterface
  end

# Returns list of the role interfaces that are added to the specified meta access role. The list of returned interfaces could be filtered
# by the name or code. Returned list does not contain any objects filtered out by executed UESQuery. The list is sorted by the name (and
# codes in case are equal) of an interface by default. See Also: <a>UES Query Documentation</a>.
# 
# <tt><b>param</b></tt> metaAccessRoleUri UES URI of the meta access role for which the added role interfaces are to be listed
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing added role interfaces
# 
# <tt><b>return</b></tt> List of DTO representing role interfaces which are added to the specified meta access role
# 
# <tt><b>throws</b></tt> UESMetaAccessRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.getRoleInterfaceList(metaAccessRoleUri, criteria = nil)
    metaAccessRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaAccessRoleUri).to_java
    criteria = Ues::Core::Role::UESMetaAccessRoleGetRoleInterfaceList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaAccessRole.java_class)
    _r = _s.getRoleInterfaceList(metaAccessRoleUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESMetaAccessRole
    alias role_interface_list getRoleInterfaceList
  end

# Copy a meta access role. The command creates a new meta access role according to specified source meta access role in a specified
# location. At the very least location meta access role and name must be specified in UESMetaAccessRoleCopy DTO. Competent role for the
# new meta access role copy will be selected as the most suitable according to specified container and meta access role
# (executive/authorized role with connected interface), or can be also specified in UESMetaAccessRoleCopy DTO.
# 
# <tt><b>param</b></tt> sourceMetaArtifactUri UESURI of the meta access role which will be copied.
# 
# <tt><b>param</b></tt> metaAccessRole DTO containing attributes of the new meta access role copy.
# 
# <tt><b>return</b></tt> UESURI of the copied meta access role.
# 
# <tt><b>throws</b></tt> UESMetaAccessRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.copy(sourceMetaArtifactUri, metaAccessRole = nil)
    sourceMetaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(sourceMetaArtifactUri).to_java
    metaAccessRole = Ues::Core::Role::UESMetaAccessRoleCopy.new(metaAccessRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaAccessRole.java_class)
    _r = _s.copy(sourceMetaArtifactUri, metaAccessRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command exports a meta access role to a DataFile, which is saved to the Export Storage. The export is an asynchronous event. That
# is why it returns a process URI to enable the user to wait for the process to finish.
# 
# <tt><b>param</b></tt> metaAccessRoleUri UESURI of the meta access role to export
# 
# <tt><b>param</b></tt> metaAccessRole DTO that contains attributes of the export process
# 
# <tt><b>return</b></tt> UESURI of the export process
# 
# <tt><b>throws</b></tt> UESMetaAccessRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.export(metaAccessRoleUri, metaAccessRole = nil)
    metaAccessRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaAccessRoleUri).to_java
    metaAccessRole = Ues::Core::Role::UESMetaAccessRoleExport.new(metaAccessRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaAccessRole.java_class)
    _r = _s.export(metaAccessRoleUri, metaAccessRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command returns a data file generated by the export command. The file contains an exported meta access role.
# 
# <tt><b>param</b></tt> metaAccessRoleUri UESURI of the meta access role we want to get the exported file from.
# 
# <tt><b>param</b></tt> metaAccessRole DTO that contains attributes concerning the file returned.
# 
# <tt><b>return</b></tt> Data file of an exported meta access role.
# 
# <tt><b>throws</b></tt> UESMetaAccessRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.getExportData(metaAccessRoleUri, metaAccessRole = nil)
    metaAccessRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaAccessRoleUri).to_java
    metaAccessRole = Ues::Core::Role::UESMetaAccessRoleGetExportData.new(metaAccessRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaAccessRole.java_class)
    _r = _s.getExportData(metaAccessRoleUri, metaAccessRole)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESMetaAccessRole
    alias export_data getExportData
  end

# Creates a meta access role from an exported XML file in the specified location.
# Source meta artifact must be derived (at least indirectly) from a meta artifact which is a part of UU.OS uuApp.
# Creation of meta artifact is divided into synchronous and asynchronous part. During the synchronous part, the meta artifact is created.
# During the asynchronous part, the template objects are created. If the asynchronous process fails and the Problem state is set on meta artifact,
# it is possible to solve the problem (e.g. add reference_map) and run the command again.
# 
# <tt><b>param</b></tt> locationUri UESURI of the Meta Model Dictionary where new Meta Access Role is created.
# 
# <tt><b>param</b></tt> metaAccessRole DTO that contains attributes of the new Meta Access Role.
# 
# <tt><b>return</b></tt> Data file of an exported Meta Access Role.
# 
# <tt><b>throws</b></tt> UESURI of the new Meta Access Role.
# 
# <tt><b>deprecated</b></tt> This command is backward incompatible (older versions of the meta artifact's XML can be unsupported). New commands will be
# prepared for creating object templates.
# 
# <tt><b>since</b></tt> UES8-02
  def self.create(locationUri, metaAccessRole = nil)
    warn "[DEPRECATED: Ues::Core::Role::UESMetaAccessRole.create] This command is backward incompatible (older versions of the meta artifact's XML can be unsupported). New commands will be
            prepared for creating object templates."
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    metaAccessRole = Ues::Core::Role::UESMetaAccessRoleCreate.new(metaAccessRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaAccessRole.java_class)
    _r = _s.create(locationUri, metaAccessRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
end
