#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES8-02
class Ues::Core::Role::UESMetaGroup
  private_class_method :new

  BEMETAGROUP_CODE = Java::cz.ues.core.role.UESMetaGroup::BEMETAGROUP_CODE #:nodoc:

  # URI of meata group business entity.
# 
# <tt><b>since</b></tt> UES8-02
  BETYPE_GROUP = Java::cz.ues.core.role.UESMetaGroup::BETYPE_GROUP


# This command returns attributes representing the meta group specified by the metaGroupUri parameter. The command does not
# change the state of the meta group in the system.
# 
# <tt><b>param</b></tt> metaGroupUri UESURI of a meta group whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the meta group attributes
# 
# <tt><b>throws</b></tt> UESMetaGroupRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.getAttributes(metaGroupUri)
    metaGroupUri = Ues::Core::Commons::Uri::UESURI.new(metaGroupUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaGroup.java_class)
    _r = _s.getAttributes(metaGroupUri)
    if (_r != nil) then _r = Ues::Core::Role::UESMetaGroupAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESMetaGroup
    alias attributes getAttributes
  end

# Command for setting attributes of a meta group. The command can't modify references to objects like location, competent group and so
# on.
# 
# <tt><b>param</b></tt> metaGroupUri UESURI of a meta group whose attributes shall be modified
# 
# <tt><b>param</b></tt> metaGroup DTO containing new attributes of the meta group
# 
# <tt><b>return</b></tt> UESURI of the meta group
# 
# <tt><b>throws</b></tt> UESMetaGroupRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.setAttributes(metaGroupUri, metaGroup = nil)
    metaGroupUri = Ues::Core::Commons::Uri::UESURI.new(metaGroupUri).to_java
    metaGroup = Ues::Core::Role::UESMetaGroupSetAttributes.new(metaGroup).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaGroup.java_class)
    _r = _s.setAttributes(metaGroupUri, metaGroup)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESMetaGroup
    alias set_attributes setAttributes
  end

# This command creates new role interface connection to the specified meta group. The role interface has to be in an active state and
# must not be already added. The role interface can be added to meta group only provided that role interface is located in the same,
# child or parent meta model as meta group.
# 
# <tt><b>param</b></tt> metaGroupUri UES URI of the meta group where the role interface will be added
# 
# <tt><b>param</b></tt> roleInterface DTO containing role interface that to be added
# 
# <tt><b>throws</b></tt> UESMetaGroupRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.addRoleInterface(metaGroupUri, roleInterface = nil)
    metaGroupUri = Ues::Core::Commons::Uri::UESURI.new(metaGroupUri).to_java
    roleInterface = Ues::Core::Role::UESMetaGroupAddRoleInterface.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaGroup.java_class)
    _r = _s.addRoleInterface(metaGroupUri, roleInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESMetaGroup
    alias add_role_interface addRoleInterface
  end

# The command removes role interface connection from the specified meta group. Only added interfaces can be removed from meta group.
# 
# <tt><b>param</b></tt> metaGroupUri UES URI of the meta group where the role interface will be removed
# 
# <tt><b>param</b></tt> roleInterface DTO containing role interface that to be removed
# 
# <tt><b>throws</b></tt> UESMetaGroupRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.removeRoleInterface(metaGroupUri, roleInterface = nil)
    metaGroupUri = Ues::Core::Commons::Uri::UESURI.new(metaGroupUri).to_java
    roleInterface = Ues::Core::Role::UESMetaGroupRemoveRoleInterface.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaGroup.java_class)
    _r = _s.removeRoleInterface(metaGroupUri, roleInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESMetaGroup
    alias remove_role_interface removeRoleInterface
  end

# Returns list of the role interfaces that are added to the specified meta group. The list of returned interfaces could be filtered by
# the name or code. Returned list does not contain any objects filtered out by executed UESQuery. The list is sorted by the name (and
# codes in case names are equal) of an interface by default. See Also: <a>UES Query Documentation</a>.
# 
# <tt><b>param</b></tt> metaGroupUri UES URI of the meta group for which the added role interfaces are to be listed
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing added role interfaces
# 
# <tt><b>return</b></tt> List of DTO representing role interfaces which are added to the specified meta group
# 
# <tt><b>throws</b></tt> UESMetaGroupRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.getRoleInterfaceList(metaGroupUri, criteria = nil)
    metaGroupUri = Ues::Core::Commons::Uri::UESURI.new(metaGroupUri).to_java
    criteria = Ues::Core::Role::UESMetaGroupGetRoleInterfaceList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaGroup.java_class)
    _r = _s.getRoleInterfaceList(metaGroupUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESMetaGroup
    alias role_interface_list getRoleInterfaceList
  end

# Copy a meta group. The command creates a new meta group according to specified source meta group in a specified location. At the very
# least location meta group and name must be specified in UESMetaGroupCopy DTO. Competent role for the new meta group copy will be
# selected as the most suitable according to specified container and meta group (executive/authorized role with connected interface), or
# can be also specified in UESMetaGroupCopy DTO.
# 
# <tt><b>param</b></tt> sourceMetaArtifactUri UESURI of the meta group which will be copied.
# 
# <tt><b>param</b></tt> metaGroup DTO containing attributes of the new meta group copy.
# 
# <tt><b>return</b></tt> UESURI of the copied meta group.
# 
# <tt><b>throws</b></tt> UESMetaGroupRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.copy(sourceMetaArtifactUri, metaGroup = nil)
    sourceMetaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(sourceMetaArtifactUri).to_java
    metaGroup = Ues::Core::Role::UESMetaGroupCopy.new(metaGroup).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaGroup.java_class)
    _r = _s.copy(sourceMetaArtifactUri, metaGroup)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command exports a meta group to a DataFile, which is saved to the Export Storage. The export is an asynchronous event. That is why
# it returns a process URI to enable the user to wait for the process to finish.
# 
# <tt><b>param</b></tt> metaGroupUri UESURI of the meta group to export
# 
# <tt><b>param</b></tt> metaGroup DTO that contains attributes of the export process
# 
# <tt><b>return</b></tt> UESURI of the export process
# 
# <tt><b>throws</b></tt> UESMetaGroupRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.export(metaGroupUri, metaGroup = nil)
    metaGroupUri = Ues::Core::Commons::Uri::UESURI.new(metaGroupUri).to_java
    metaGroup = Ues::Core::Role::UESMetaGroupExport.new(metaGroup).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaGroup.java_class)
    _r = _s.export(metaGroupUri, metaGroup)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command returns a data file generated by the export command. The file contains an exported meta group.
# 
# <tt><b>param</b></tt> metaGroupUri UESURI of the meta group we want to get the exported file from.
# 
# <tt><b>param</b></tt> metaGroup DTO that contains attributes concerning the file returned.
# 
# <tt><b>return</b></tt> Data file of an exported meta group.
# 
# <tt><b>throws</b></tt> UESMetaGroupRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.getExportData(metaGroupUri, metaGroup = nil)
    metaGroupUri = Ues::Core::Commons::Uri::UESURI.new(metaGroupUri).to_java
    metaGroup = Ues::Core::Role::UESMetaGroupGetExportData.new(metaGroup).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaGroup.java_class)
    _r = _s.getExportData(metaGroupUri, metaGroup)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESMetaGroup
    alias export_data getExportData
  end

# Creates a meta group from an exported XML file in the specified location.
# Source meta artifact must be derived (at least indirectly) from a meta artifact which is a part of UU.OS uuApp.
# Creation of meta artifact is divided into synchronous and asynchronous part. During the synchronous part, the meta artifact is created.
# During the asynchronous part, the template objects are created. If the asynchronous process fails and the Problem state is set on meta artifact,
# it is possible to solve the problem (e.g. add reference_map) and run the command again.
# 
# <tt><b>param</b></tt> locationUri UESURI of the Meta Model Dictionary where new Meta Group is created.
# 
# <tt><b>param</b></tt> metaGroup DTO that contains attributes of the new Meta Group.
# 
# <tt><b>return</b></tt> UESURI of the new Meta Group.
# 
# <tt><b>throws</b></tt> UESMetaGroupRTException
# 
# <tt><b>deprecated</b></tt> This command is backward incompatible (older versions of the meta artifact's XML can be unsupported). New commands will be
# prepared for creating object templates.
# 
# <tt><b>since</b></tt> UES8-02
  def self.create(locationUri, metaGroup = nil)
    warn "[DEPRECATED: Ues::Core::Role::UESMetaGroup.create] This command is backward incompatible (older versions of the meta artifact's XML can be unsupported). New commands will be
            prepared for creating object templates."
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    metaGroup = Ues::Core::Role::UESMetaGroupCreate.new(metaGroup).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaGroup.java_class)
    _r = _s.create(locationUri, metaGroup)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
end
