#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES8-02
class Ues::Core::Role::UESMetaRole
  private_class_method :new

  # Code of meta role business entity.
  BEMETAROLE_CODE = Java::cz.ues.core.role.UESMetaRole::BEMETAROLE_CODE


# This command returns attributes representing the meta role specified by the metaRoleUri parameter. The command does not change the
# state of the meta role in the system.
# 
# <tt><b>param</b></tt> metaRoleUri UESURI of a meta role whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the meta role attributes
# 
# <tt><b>throws</b></tt> UESMetaRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.getAttributes(metaRoleUri)
    metaRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaRoleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaRole.java_class)
    _r = _s.getAttributes(metaRoleUri)
    if (_r != nil) then _r = Ues::Core::Role::UESMetaRoleAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESMetaRole
    alias attributes getAttributes
  end

# Command for setting attributes of a meta role. The command cannot modify references to objects like location, competent role and so on.
# 
# <tt><b>param</b></tt> metaRoleUri UESURI of the meta role whose attributes are to be set
# 
# <tt><b>param</b></tt> metaRole DTO containing new attributes of the meta role
# 
# <tt><b>return</b></tt> UESURI of the meta role
# 
# <tt><b>throws</b></tt> UESMetaRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.setAttributes(metaRoleUri, metaRole = nil)
    metaRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaRoleUri).to_java
    metaRole = Ues::Core::Role::UESMetaRoleSetAttributes.new(metaRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaRole.java_class)
    _r = _s.setAttributes(metaRoleUri, metaRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESMetaRole
    alias set_attributes setAttributes
  end

# Copy a meta role. The command creates a new meta role according to specified source meta role in a specified location. At the very
# least location meta role and name must be specified in UESMetaRoleCopy DTO. Competent role for the new meta role copy will be selected
# as the most suitable according to specified container and meta role (executive/authorized role with connected interface), or can be
# also specified in UESMetaRoleCopy DTO.
# 
# <tt><b>param</b></tt> sourceMetaArtifactUri UESURI of the meta role which will be copied.
# 
# <tt><b>param</b></tt> metaRole DTO containing attributes of the new meta role copy.
# 
# <tt><b>return</b></tt> UESURI of the copied meta role
# 
# <tt><b>throws</b></tt> UESMetaRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.copy(sourceMetaArtifactUri, metaRole = nil)
    sourceMetaArtifactUri = Ues::Core::Commons::Uri::UESURI.new(sourceMetaArtifactUri).to_java
    metaRole = Ues::Core::Role::UESMetaRoleCopy.new(metaRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaRole.java_class)
    _r = _s.copy(sourceMetaArtifactUri, metaRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command creates new role interface connection to the specified meta role. The role interface has to be in an active state and must
# not be already added. The role interface can be added to meta role only provided that role interface is located in the same, child or
# parent meta model as meta role.
# 
# <tt><b>param</b></tt> metaRoleUri UES URI of the meta role where the role interface will be added
# 
# <tt><b>param</b></tt> roleInterface DTO containing role interface that to be added
# 
# <tt><b>throws</b></tt> UESMetaRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.addRoleInterface(metaRoleUri, roleInterface = nil)
    metaRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaRoleUri).to_java
    roleInterface = Ues::Core::Role::UESMetaRoleAddRoleInterface.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaRole.java_class)
    _r = _s.addRoleInterface(metaRoleUri, roleInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESMetaRole
    alias add_role_interface addRoleInterface
  end

# Returns list of the role interfaces that are added to the specified meta role. The list of returned interfaces could be filtered by the
# name or code. Returned list does not contain any objects filtered out by executed UESQuery. The list is sorted by the name (and codes
# in case are equal) of an interface by default. See Also: <a>UES Query Documentation</a>
# 
# <tt><b>param</b></tt> metaRoleUri UES URI of the meta role for which the added role interfaces are to be listed
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing added role interfaces
# 
# <tt><b>return</b></tt> List of DTO representing role interfaces which are added to the specified meta role
# 
# <tt><b>throws</b></tt> UESMetaRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.getRoleInterfaceList(metaRoleUri, criteria = nil)
    metaRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaRoleUri).to_java
    criteria = Ues::Core::Role::UESMetaRoleGetRoleInterfaceList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaRole.java_class)
    _r = _s.getRoleInterfaceList(metaRoleUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESMetaRole
    alias role_interface_list getRoleInterfaceList
  end

# The command removes role interface connection from the specified meta role. Only added interfaces can be removed from meta role.
# 
# <tt><b>param</b></tt> metaRoleUri UES URI of the meta role where the role interface will be removed
# 
# <tt><b>param</b></tt> roleInterface DTO containing role interface that to be removed
# 
# <tt><b>throws</b></tt> UESMetaRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.removeRoleInterface(metaRoleUri, roleInterface = nil)
    metaRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaRoleUri).to_java
    roleInterface = Ues::Core::Role::UESMetaRoleRemoveRoleInterface.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaRole.java_class)
    _r = _s.removeRoleInterface(metaRoleUri, roleInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESMetaRole
    alias remove_role_interface removeRoleInterface
  end

# The command exports a meta role to a DataFile, which is saved to the Export Storage. The export is an asynchronous event. That is why
# it returns a process URI to enable the user to wait for the process to finish.
# 
# <tt><b>param</b></tt> metaRoleUri UESURI of the meta role to export
# 
# <tt><b>param</b></tt> metaRole DTO that contains attributes of the export process
# 
# <tt><b>return</b></tt> UESURI of the export process
# 
# <tt><b>throws</b></tt> UESMetaRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.export(metaRoleUri, metaRole = nil)
    metaRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaRoleUri).to_java
    metaRole = Ues::Core::Role::UESMetaRoleExport.new(metaRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaRole.java_class)
    _r = _s.export(metaRoleUri, metaRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command returns a data file generated by the export command. The file contains an exported meta role.
# 
# <tt><b>param</b></tt> metaRoleUri UESURI of the meta role we want to get the exported file from.
# 
# <tt><b>param</b></tt> metaRole DTO that contains attributes concerning the file returned.
# 
# <tt><b>return</b></tt> Data file of an exported meta role.
# 
# <tt><b>throws</b></tt> UESMetaRoleRTException
# 
# <tt><b>since</b></tt> UES8-02
  def self.getExportData(metaRoleUri, metaRole = nil)
    metaRoleUri = Ues::Core::Commons::Uri::UESURI.new(metaRoleUri).to_java
    metaRole = Ues::Core::Role::UESMetaRoleGetExportData.new(metaRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaRole.java_class)
    _r = _s.getExportData(metaRoleUri, metaRole)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESMetaRole
    alias export_data getExportData
  end

# Creates a meta role from an exported XML file in the specified location.
# Source meta role must be derived (at least indirectly) from a meta artifact which is a part of UU.OS uuApp.
# Creation of meta role is divided into synchronous and asynchronous part. During the synchronous part,
# the meta role is created. During the asynchronous part, the template objects are created. If the asynchronous process fails
# and the Problem state is set on meta role, it is possible to solve the problem (e.g. add reference_map) and run the command again.
# 
# <tt><b>param</b></tt> locationUri UESURI of the Meta Model Dictionary where new Meta Role is created.
# 
# <tt><b>param</b></tt> metaRole DTO that contains attributes of the new Meta Role.
# 
# <tt><b>return</b></tt> UESURI of the new Meta Role.
# 
# <tt><b>throws</b></tt> UESMetaRoleRTException
# 
# <tt><b>deprecated</b></tt> This command is backward incompatible (older versions of the meta artifact's XML can be unsupported). New commands will be
# prepared for creating object templates.
# 
# <tt><b>since</b></tt> UES8-02
  def self.create(locationUri, metaRole = nil)
    warn "[DEPRECATED: Ues::Core::Role::UESMetaRole.create] This command is backward incompatible (older versions of the meta artifact's XML can be unsupported). New commands will be
            prepared for creating object templates."
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    metaRole = Ues::Core::Role::UESMetaRoleCreate.new(metaRole).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESMetaRole.java_class)
    _r = _s.create(locationUri, metaRole)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
end
