#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES6-06
class Ues::Core::Role::UESRole
  private_class_method :new

  BEROLE_CODE = Java::cz.ues.core.role.UESRole::BEROLE_CODE #:nodoc:

  # URI of role business entity.
# 
# <tt><b>since</b></tt> UES6-06
  BETYPE_ROLE = Java::cz.ues.core.role.UESRole::BETYPE_ROLE


# Creates a new role. The command creates a new role in a specified location. At the very least meta artifact must be specified in
# UESRoleCreate DTO. Competent role for the new role will be selected as the most suitable according to specified container and
# meta artifact (executive/authorized role with connected interface), or can be also specified in UESRoleCreate DTO.
# 
# <tt><b>param</b></tt> locationUri UESURI of the folder/org. unit/meta model where the role will be created.
# 
# <tt><b>param</b></tt> role DTO containing attributes of the new role
# 
# <tt><b>return</b></tt> UESURI of the new role
# 
# <tt><b>throws</b></tt> UESRoleRTException
# 
# <tt><b>since</b></tt> UES6-06
  def self.create(locationUri, role = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    role = Ues::Core::Role::UESRoleCreate.new(role).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRole.java_class)
    _r = _s.create(locationUri, role)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command returns attributes representing the role specified by the roleUri parameter. The command does not change the state of the
# role in the system.
# 
# <tt><b>param</b></tt> roleUri UESURI of the role
# 
# <tt><b>return</b></tt> DTO with role attributes.
# 
# <tt><b>throws</b></tt> UESRoleRTException
# 
# <tt><b>since</b></tt> UES6-06
  def self.getAttributes(roleUri)
    roleUri = Ues::Core::Commons::Uri::UESURI.new(roleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRole.java_class)
    _r = _s.getAttributes(roleUri)
    if (_r != nil) then _r = Ues::Core::Role::UESRoleAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESRole
    alias attributes getAttributes
  end

# Command for setting attributes of a role. The command can't modify references to objects like location, competent role and so on.
# 
# <tt><b>param</b></tt> roleUri UESURI of the role whose attributes are to be changed
# 
# <tt><b>param</b></tt> role DTO containing new attributes for the role
# 
# <tt><b>return</b></tt> UESURI of the role
# 
# <tt><b>throws</b></tt> UESRoleRTException
# 
# <tt><b>since</b></tt> UES6-06
  def self.setAttributes(roleUri, role = nil)
    roleUri = Ues::Core::Commons::Uri::UESURI.new(roleUri).to_java
    role = Ues::Core::Role::UESRoleSetAttributes.new(role).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRole.java_class)
    _r = _s.setAttributes(roleUri, role)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESRole
    alias set_attributes setAttributes
  end

# This command deletes the specified role from the system. The role is deleted even if it contains a locked sheet or attachment. The role
# cannot be deleted when:
# 
# 
# * the role is not in an active cast.
# 
# * the role's workflow is not created
# 
# * a property contains a reference to this role
# 
# * a time sheet exists with a reference to this role
# 
# * an artifact exists with this role as competent role
# 
# * an activity exists with this role as competent role
# 
# 
# 
# 
# <tt><b>param</b></tt> roleUri UESURI of the role which is about to be deleted.
# 
# <tt><b>throws</b></tt> UESRoleRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.delete(roleUri)
    roleUri = Ues::Core::Commons::Uri::UESURI.new(roleUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRole.java_class)
    _r = _s.delete(roleUri)
    
    return _r
  end

# This command returns a list of entries representing the artifacts for that the specified role is competent. The list is sorted by the
# name (and codes in case are equal) of a entry by default.
# 
# <tt><b>param</b></tt> roleUri UESURI of the role that is competent for the searched artifacts
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing role's artifacts.
# 
# <tt><b>return</b></tt> List of DTO representing artifacts for that the specified role is competent.
# 
# <tt><b>throws</b></tt> UESArtifactSearchRTException
# 
# <tt><b>since</b></tt> UES7-06
  def self.getArtifactList(roleUri, criteria = nil)
    roleUri = Ues::Core::Commons::Uri::UESURI.new(roleUri).to_java
    criteria = Ues::Core::Role::UESRoleGetArtifactList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRole.java_class)
    _r = _s.getArtifactList(roleUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESRole
    alias artifact_list getArtifactList
  end

# This command creates new role interface connection to the specified role. The role interface has to be in an active state and mustn't
# be already connected. The role interface has to be connected to the one of the authorized roles for this command, or the authorized
# role has to be casted to the default group of meta model where the role interface is located.
# 
# <tt><b>param</b></tt> roleUri UESURI of the role where the role interface will be connected
# 
# <tt><b>param</b></tt> roleInterface DTO containing role interface that to be connected
# 
# <tt><b>throws</b></tt> UESRoleRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.addRoleInterface(roleUri, roleInterface = nil)
    roleUri = Ues::Core::Commons::Uri::UESURI.new(roleUri).to_java
    roleInterface = Ues::Core::Role::UESRoleAddRoleInterface.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRole.java_class)
    _r = _s.addRoleInterface(roleUri, roleInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESRole
    alias add_role_interface addRoleInterface
  end

# The command removes role interface connection from the specified role. Only connected interfaces can be disconnected from role.
# 
# <tt><b>param</b></tt> roleInterfaceUri UESURI of the role where the role interface will be disconnected.
# 
# <tt><b>param</b></tt> roleInterface DTO containing role interface that to be disconnected
# 
# <tt><b>throws</b></tt> UESRoleRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.removeRoleInterface(roleUri, roleInterface = nil)
    roleUri = Ues::Core::Commons::Uri::UESURI.new(roleUri).to_java
    roleInterface = Ues::Core::Role::UESRoleRemoveRoleInterface.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRole.java_class)
    _r = _s.removeRoleInterface(roleUri, roleInterface)
    
    return _r
  end
  class << Ues::Core::Role::UESRole
    alias remove_role_interface removeRoleInterface
  end

# Returns list of the role interfaces that are connected to the specified role. Returned list does not contain any objects filtered out
# by executed UESQuery. See Also: <a>UES Query Documentation</a>
# 
# <tt><b>param</b></tt> roleUri UES URI of the role for which the connected role interfaces are to be listed
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing connected role interfaces
# 
# <tt><b>return</b></tt> List of DTO representing role interfaces which are connected to the specified role
# 
# <tt><b>throws</b></tt> UESRoleRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getRoleInterfaceList(roleUri, criteria = nil)
    roleUri = Ues::Core::Commons::Uri::UESURI.new(roleUri).to_java
    criteria = Ues::Core::Role::UESRoleGetRoleInterfaceList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRole.java_class)
    _r = _s.getRoleInterfaceList(roleUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESRole
    alias role_interface_list getRoleInterfaceList
  end
end
