#--
# This code is automatically generated, do not modify the content !!!
#++
# 
# 
# <tt><b>since</b></tt> UES7-10
class Ues::Core::Role::UESRoleInterface
  private_class_method :new

  # Code of role interface business entity.
  BEROLE_INTERFACE_CODE = Java::cz.ues.core.role.UESRoleInterface::BEROLE_INTERFACE_CODE

  # URI of role interface business entity.
# 
# <tt><b>since</b></tt> UES7-10
  BETYPE_ROLE_INTERFACE = Java::cz.ues.core.role.UESRoleInterface::BETYPE_ROLE_INTERFACE


# Creates a new role interface. The command creates a new role interface in a specified meta model dictionary. At the very least meta
# artifact, name and code must be specified in UESRoleInterfaceCreate DTO. Competent role for the new group will be selected as
# the most suitable according to specified container and meta artifact (executive/authorized role with connected interface), or can be
# also specified in UESRoleInterfaceCreate DTO.
# 
# <tt><b>param</b></tt> locationUri UESURI of the meta model dictionary where the role interface will be created.
# 
# <tt><b>param</b></tt> roleInterface DTO containing attributes of the new role interface.
# 
# <tt><b>return</b></tt> UESURI of the new role interface
# 
# <tt><b>throws</b></tt> UESRoleInterfaceRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.create(locationUri, roleInterface = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    roleInterface = Ues::Core::Role::UESRoleInterfaceCreate.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRoleInterface.java_class)
    _r = _s.create(locationUri, roleInterface)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command returns attributes representing the role interface specified by the roleInterfaceUri parameter. The command does not
# change the state of the role interface in the system.
# 
# <tt><b>param</b></tt> roleInterfaceUri UESURI of a role interface whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the role interface attributes
# 
# <tt><b>throws</b></tt> UESRoleInterfaceRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getAttributes(roleInterfaceUri)
    roleInterfaceUri = Ues::Core::Commons::Uri::UESURI.new(roleInterfaceUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRoleInterface.java_class)
    _r = _s.getAttributes(roleInterfaceUri)
    if (_r != nil) then _r = Ues::Core::Role::UESRoleInterfaceAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESRoleInterface
    alias attributes getAttributes
  end

# Command for setting attributes of a role interface. The command can't modify references to objects like location, competent role and so
# on.
# 
# <tt><b>param</b></tt> roleInterfaceUri UESURI of the role interface whose attributes are to be changed
# 
# <tt><b>param</b></tt> roleInterface DTO containing new attributes the role interface
# 
# <tt><b>return</b></tt> UESURI of the role interface
# 
# <tt><b>throws</b></tt> UESRoleInterfaceRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.setAttributes(roleInterfaceUri, roleInterface = nil)
    roleInterfaceUri = Ues::Core::Commons::Uri::UESURI.new(roleInterfaceUri).to_java
    roleInterface = Ues::Core::Role::UESRoleInterfaceSetAttributes.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRoleInterface.java_class)
    _r = _s.setAttributes(roleInterfaceUri, roleInterface)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESRoleInterface
    alias set_attributes setAttributes
  end

# This command deletes the specified role interface from the system. The role interface is deleted even if it contains a locked sheet or
# attachment. The role interface cannot be deleted when:
# 
# 
# * the role interface's workflow is not created
# 
# * a property contains a reference to this role interface
# 
# * a time sheet exists with a reference to this role interface
# 
# 
# 
# 
# <tt><b>param</b></tt> roleInterfaceUri UESURI of the role interface which is about to be deleted.
# 
# <tt><b>throws</b></tt> UESRoleInterfaceRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.delete(roleInterfaceUri)
    roleInterfaceUri = Ues::Core::Commons::Uri::UESURI.new(roleInterfaceUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRoleInterface.java_class)
    _r = _s.delete(roleInterfaceUri)
    
    return _r
  end

# The command creates new meta artifact connection to the specified role interface.
# 
# <tt><b>param</b></tt> roleInterfaceUri UESURI of the role interface where the meta artifacts will be connected
# 
# <tt><b>param</b></tt> metaArtifact DTO containing meta artifact that to be connected
# 
# <tt><b>throws</b></tt> UESRoleInterfaceRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.addMetaArtifact(roleInterfaceUri, metaArtifact = nil)
    roleInterfaceUri = Ues::Core::Commons::Uri::UESURI.new(roleInterfaceUri).to_java
    metaArtifact = Ues::Core::Role::UESRoleInterfaceAddMetaArtifact.new(metaArtifact).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRoleInterface.java_class)
    _r = _s.addMetaArtifact(roleInterfaceUri, metaArtifact)
    
    return _r
  end
  class << Ues::Core::Role::UESRoleInterface
    alias add_meta_artifact addMetaArtifact
  end

# The command removes meta artifact connection from the specified role interface. Only connected meta artifacts can be disconnected from
# the role interface.
# 
# <tt><b>param</b></tt> roleInterfaceUri UESURI of the role interface where the meta artifacts will be disconnected.
# 
# <tt><b>param</b></tt> metaArtifact DTO containing meta artifact that to be disconnected
# 
# <tt><b>throws</b></tt> UESRoleInterfaceRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.removeMetaArtifact(roleInterfaceUri, metaArtifact = nil)
    roleInterfaceUri = Ues::Core::Commons::Uri::UESURI.new(roleInterfaceUri).to_java
    metaArtifact = Ues::Core::Role::UESRoleInterfaceRemoveMetaArtifact.new(metaArtifact).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRoleInterface.java_class)
    _r = _s.removeMetaArtifact(roleInterfaceUri, metaArtifact)
    
    return _r
  end
  class << Ues::Core::Role::UESRoleInterface
    alias remove_meta_artifact removeMetaArtifact
  end

# Returns list of the meta artifacts that are connected to the specified role interface. Returned list does not contain any objects
# filtered out by executed UESQuery. The list of returned meta artifacts could be filtered by the name or code. The list is sorted by the
# name (and codes in case are equal). See the UES query documentation for more information.
# 
# <tt><b>param</b></tt> roleInterfaceUri UES URI of the role interface for which the connected meta artifacts are to be listed
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing connected meta artifacts. Available parameters are:
# cz.ues.core.role.dto.UESRoleInterfaceGetMetaArtifactListItem#name name and
# cz.ues.core.role.dto.UESRoleInterfaceGetMetaArtifactListItem#code code
# 
# <tt><b>return</b></tt> List of DTO representing meta artifacts which are connected to the specified role interface
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>since</b></tt> UES7-10
  def self.getMetaArtifactList(roleInterfaceUri, criteria = nil)
    roleInterfaceUri = Ues::Core::Commons::Uri::UESURI.new(roleInterfaceUri).to_java
    criteria = Ues::Core::Role::UESRoleInterfaceGetMetaArtifactList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRoleInterface.java_class)
    _r = _s.getMetaArtifactList(roleInterfaceUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESRoleInterface
    alias meta_artifact_list getMetaArtifactList
  end

# The command exports a role interface to a DataFile, which is saved to the Export Storage. The export is an asynchronous event. That is
# why it returns a process URI to enable the user to wait for the process to finish.
# 
# <tt><b>param</b></tt> roleInterfaceUri UESURI of the role interface to export
# 
# <tt><b>param</b></tt> roleInterface DTO that contains attributes of the export process
# 
# <tt><b>return</b></tt> UESURI of the export process
# 
# <tt><b>throws</b></tt> UESRoleInterfaceRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.export(roleInterfaceUri, roleInterface = nil)
    roleInterfaceUri = Ues::Core::Commons::Uri::UESURI.new(roleInterfaceUri).to_java
    roleInterface = Ues::Core::Role::UESRoleInterfaceExport.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRoleInterface.java_class)
    _r = _s.export(roleInterfaceUri, roleInterface)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command returns a data file generated by the export command. The file contains an exported role interface.
# 
# <tt><b>param</b></tt> roleInterfaceUri UESURI of the role interface we want to get the exported file from.
# 
# <tt><b>param</b></tt> roleInterface DTO that contains attributes concerning the file returned.
# 
# <tt><b>return</b></tt> Data file of an exported role interface.
# 
# <tt><b>throws</b></tt> UESRoleInterfaceRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.getExportData(roleInterfaceUri, roleInterface = nil)
    roleInterfaceUri = Ues::Core::Commons::Uri::UESURI.new(roleInterfaceUri).to_java
    roleInterface = Ues::Core::Role::UESRoleInterfaceGetExportData.new(roleInterface).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRoleInterface.java_class)
    _r = _s.getExportData(roleInterfaceUri, roleInterface)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESRoleInterface
    alias export_data getExportData
  end

# Returns list of roles, which the specified role interface is connected to.
# 
# <tt><b>param</b></tt> roleInterfaceUri UESURI of the role interface to retrieve the roles it is connected to.
# 
# <tt><b>param</b></tt> criteria Object containing paging criteria.
# 
# <tt><b>return</b></tt> Returns list of Objects representing roles, which the specified role interface is connected to. Contains instances of
# (RoleInterfaceGetRoleListItem).
# 
# <tt><b>throws</b></tt> UESRoleInterfaceRTException
# 
# <tt><b>since</b></tt> UES8-08
  def self.getRoleList(roleInterfaceUri, criteria = nil)
    roleInterfaceUri = Ues::Core::Commons::Uri::UESURI.new(roleInterfaceUri).to_java
    criteria = Ues::Core::Role::UESRoleInterfaceGetRoleList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.role.UESRoleInterface.java_class)
    _r = _s.getRoleList(roleInterfaceUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Role::UESRoleInterface
    alias role_list getRoleList
  end
end
