require 'json'
require 'cz/ues/platform/process/UESFuture'

extClass = Ues::Core::Script::UESScript

class << extClass
  alias old_exec exec
end

def extClass.exec(mainEntityUri, parameters = nil)
  # Convert any parameters and options to plain JSON String.
  # (JAXB fails with Map or Hash in attribute of type Object)
  parameters = Ues::Core::Script::UESScriptExec.new(parameters)
  dto = parameters.instance_variable_get('@dtoValue')
  data = dto.getData()
  if data.java_kind_of?Java::java.util.Map
    dto.setData(data.to_hash.to_json)
  elsif data.java_kind_of?Hash
    dto.setData(data.to_json)
  end
  options = dto.getOptions()
  if options.java_kind_of?Java::java.util.Map
    dto.setOptions(options.to_hash.to_json)
  elsif options.java_kind_of?Hash
    dto.setOptions(options.to_json)
  end
  # Call original exec method with modified DTO.
  uri =  self.old_exec(mainEntityUri, parameters)
  # return Future instead of process uri
  return Ues::Platform::Process::UESFuture.new(uri)
end
