#--
# This code is automatically generated, do not modify the content !!!
#++
# Service representing session of authenticated user.
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES6-06
class Ues::Core::Security::Session::UESSession
  private_class_method :new


# Returns personal role URI of authenticated user.
# 
# <tt><b>return</b></tt> URI of personal role
# 
# <tt><b>throws</b></tt> UESSessionRTException In case URI cannot be obtained
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES6-06
  def self.getPersonalRole()
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.session.UESSession.java_class)
    _r = _s.getPersonalRole()
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Security::Session::UESSession
    alias personal_role getPersonalRole
  end

# Returns personal role of user who initiated session (did the first login).
# 
# <tt><b>return</b></tt> URI of initiator personal role
# 
# <tt><b>throws</b></tt> UESSessionRTException In case URI cannot be obtained
# 
# <tt><b>since</b></tt> UES8-05
  def self.getInitiatorPersonalRole()
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.session.UESSession.java_class)
    _r = _s.getInitiatorPersonalRole()
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Security::Session::UESSession
    alias initiator_personal_role getInitiatorPersonalRole
  end

# Returns access role URI of authenticated user in given territory. May return null in case user has no access role in territory.
# 
# <tt><b>param</b></tt> territoryUri URI of territory for which to get access role
# 
# <tt><b>return</b></tt> URI of access role or null
# 
# <tt><b>throws</b></tt> UESSessionRTException In case URI cannot be obtained
# 
# <tt><b>since</b></tt> UES8-05
  def self.getAccessRole(territoryUri)
    territoryUri = Ues::Core::Commons::Uri::UESURI.new(territoryUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.session.UESSession.java_class)
    _r = _s.getAccessRole(territoryUri)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Security::Session::UESSession
    alias access_role getAccessRole
  end

# Returns access role URI of user who initiated session in given territory. May return null in case user has no access role in territory.
# 
# <tt><b>param</b></tt> territoryUri URI of territory for which to get access role
# 
# <tt><b>return</b></tt> URI of initiator access role or null
# 
# <tt><b>throws</b></tt> UESSessionRTException In case URI cannot be obtained
# 
# <tt><b>since</b></tt> UES8-05
  def self.getInitiatorAccessRole(territoryUri)
    territoryUri = Ues::Core::Commons::Uri::UESURI.new(territoryUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.security.session.UESSession.java_class)
    _r = _s.getInitiatorAccessRole(territoryUri)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Security::Session::UESSession
    alias initiator_access_role getInitiatorAccessRole
  end
end
