#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Core::Sysc::App
  private_class_method :new

  BEAPP_CODE = Java::cz.ues.core.sysc.App::BEAPP_CODE #:nodoc:

  # URI of App business entity.
# 
# <tt><b>since</b></tt> UES7-10
  BETYPE_APP = Java::cz.ues.core.sysc.App::BETYPE_APP


# Creates a new application. The command creates a new application in a specified location. At the very least meta artifact must be
# specified in AppCreate DTO. Competent role for the application will be selected as the most suitable according to specified
# container and meta artifact(executive/authorized role with connected interface), or can be also specified in AppCreate DTO.
# When UESURI applicationUri of AppBox from which should be App created is not specified, Dev Application will be
# created. Dev Application serves for development of own Applications in Business territory and has no individual SLA.
# 
# <tt><b>param</b></tt> locationUri UESURI of the folder/org. unit/meta model where application will be created.
# 
# <tt><b>param</b></tt> DTO containing attributes of the new application
# 
# <tt><b>return</b></tt> UESURI of the new application
# 
# <tt><b>throws</b></tt> AppRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.create(locationUri, app = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    app = Ues::Core::Sysc::AppCreate.new(app).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.App.java_class)
    _r = _s.create(locationUri, app)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command returns attributes representing the application specified by the appUri parameter. The command does not change the state
# of the application in the system.
# 
# <tt><b>param</b></tt> appUri UESURI of an application whose attributes are returned
# 
# <tt><b>return</b></tt> DTO containing the application attributes
# 
# <tt><b>throws</b></tt> AppRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.getAttributes(appUri)
    appUri = Ues::Core::Commons::Uri::UESURI.new(appUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.App.java_class)
    _r = _s.getAttributes(appUri)
    if (_r != nil) then _r = Ues::Core::Sysc::AppAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::App
    alias attributes getAttributes
  end

# Command for setting attributes of an application. The command can't modify references to objects like location, competent role and so
# on.
# 
# <tt><b>param</b></tt> appUri UESURI of the application whose attributes are to be changed
# 
# <tt><b>param</b></tt> app DTO containing new attributes the application
# 
# <tt><b>return</b></tt> UESURI of the application
# 
# <tt><b>throws</b></tt> AppRTException
# 
# <tt><b>since</b></tt> UES7-10
  def self.setAttributes(appUri, app = nil)
    appUri = Ues::Core::Commons::Uri::UESURI.new(appUri).to_java
    app = Ues::Core::Sysc::AppSetAttributes.new(app).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.App.java_class)
    _r = _s.setAttributes(appUri, app)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::App
    alias set_attributes setAttributes
  end

# This command returns a list of entries (artifacts or shortcuts) enlisted in the specified application. Only entries listed exactly in
# the specified applications are considered (so subordinate applications are not considered). The command does not return all entries,
# only a sublist. The list of returned entries could be filtered by the name or code. The list is sorted by the name (and codes in case
# are equal) of a entry by default, or it can be sorted arbitrarily by any of entry attributes usable for the filtering or these
# attributes combinations. See the UES query documentation for more information.
# 
# <tt><b>param</b></tt> appUri UESURI of the application from where entries (artifacts or shortcuts) are listed.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing entries Available parameters are: AppEntryAttributes#name name and
# AppEntryAttributes#code code.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>since</b></tt> UES7-10
# 
# <tt><b>return</b></tt> List of DTO representing entries of the appUri (artifacts or shortcuts).
  def self.getEntryList(appUri, criteria = nil)
    appUri = Ues::Core::Commons::Uri::UESURI.new(appUri).to_java
    criteria = Ues::Core::Sysc::AppGetEntryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.App.java_class)
    _r = _s.getEntryList(appUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::App
    alias entry_list getEntryList
  end

  def self.install(territoryUri, appParameters = nil)
    territoryUri = Ues::Core::Commons::Uri::UESURI.new(territoryUri).to_java
    appParameters = Ues::Core::Sysc::AppParameters.new(appParameters).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.App.java_class)
    _r = _s.install(territoryUri, appParameters)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

  def self.installSharedMetaModel(territoryUri, appParameters = nil)
    territoryUri = Ues::Core::Commons::Uri::UESURI.new(territoryUri).to_java
    appParameters = Ues::Core::Sysc::AppParameters.new(appParameters).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.App.java_class)
    _r = _s.installSharedMetaModel(territoryUri, appParameters)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::App
    alias install_shared_meta_model installSharedMetaModel
  end
end
