#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Core::Sysc::Command
  private_class_method :new

  BE_COMMAND_CODE = Java::cz.ues.core.sysc.Command::BE_COMMAND_CODE #:nodoc:

  # URI of Command business entity.
# 
# <tt><b>since</b></tt> UES8-09
  BETYPE_COMMAND = Java::cz.ues.core.sysc.Command::BETYPE_COMMAND


# The command creates a command in a specified meta model. At the very least meta artifact must be specified in CommandCreate DTO.
# Competent role for the new command will be selected as the most suitable according to specified container and meta artifact (executive/authorized
# role with connected interface), or can be also specified in CommandCreate DTO.
# 
# <tt><b>param</b></tt> locationUri UESURI of the meta model where the command will be created.
# 
# <tt><b>param</b></tt> command DTO containing attributes of the new command.
# 
# <tt><b>return</b></tt> UESURI of the new command.
# 
# <tt><b>throws</b></tt> CommandRTException
# 
# <tt><b>since</b></tt> UES8-09
  def self.create(locationUri, command = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    command = Ues::Core::Sysc::CommandCreate.new(command).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Command.java_class)
    _r = _s.create(locationUri, command)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command deletes the specified command from the system. The command fails when the specified command is referenced by some use case. The
# command is deleted even if it contains a locked sheet or attachment.
# 
# <tt><b>param</b></tt> commandUri UESURI of the command which is about to be deleted.
# 
# <tt><b>throws</b></tt> CommandRTException
# 
# <tt><b>since</b></tt> UES8-09
  def self.delete(commandUri)
    commandUri = Ues::Core::Commons::Uri::UESURI.new(commandUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Command.java_class)
    _r = _s.delete(commandUri)
    
    return _r
  end

# This command returns attributes representing the command specified by the commandUri parameter.
# 
# <tt><b>param</b></tt> commandUri UESURI of the command.
# 
# <tt><b>return</b></tt> DTO containing attributes of the command.
# 
# <tt><b>throws</b></tt> CommandRTException
# 
# <tt><b>since</b></tt> UES8-09
  def self.getAttributes(commandUri)
    commandUri = Ues::Core::Commons::Uri::UESURI.new(commandUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Command.java_class)
    _r = _s.getAttributes(commandUri)
    if (_r != nil) then _r = Ues::Core::Sysc::CommandAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::Command
    alias attributes getAttributes
  end

# The command for setting attributes of a specified command. The command can't modify references to object like storage, competent role and so on.
# 
# <tt><b>param</b></tt> commandUri UESURI of the command.
# 
# <tt><b>param</b></tt> command DTO containing new attributes of the use case.
# 
# <tt><b>return</b></tt> UESURI of the command.
# 
# <tt><b>throws</b></tt> CommandRTException
# 
# <tt><b>since</b></tt> UES8-09
  def self.setAttributes(commandUri, command = nil)
    commandUri = Ues::Core::Commons::Uri::UESURI.new(commandUri).to_java
    command = Ues::Core::Sysc::CommandSetAttributes.new(command).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Command.java_class)
    _r = _s.setAttributes(commandUri, command)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::Command
    alias set_attributes setAttributes
  end

# The command exports a command to a DataFile, which is saved to the Export Storage. The export is an asynchronous event. That is
# why it returns a process URI to enable the user to wait for the process to finish.
# 
# <tt><b>param</b></tt> commandUri UESURI of the command to export
# 
# <tt><b>param</b></tt> command DTO that contains attributes of the export process
# 
# <tt><b>return</b></tt> UESURI of the export process
# 
# <tt><b>throws</b></tt> CommandRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.export(commandUri, command = nil)
    commandUri = Ues::Core::Commons::Uri::UESURI.new(commandUri).to_java
    command = Ues::Core::Sysc::CommandExport.new(command).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Command.java_class)
    _r = _s.export(commandUri, command)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command returns a data file generated by the export command. The file contains an exported command.
# 
# <tt><b>param</b></tt> commandUri UESURI of the command we want to get the exported file from.
# 
# <tt><b>param</b></tt> command DTO that contains attributes concerning the file returned.
# 
# <tt><b>return</b></tt> Data file of an exported command.
# 
# <tt><b>throws</b></tt> CommandRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.getExportData(commandUri, command = nil)
    commandUri = Ues::Core::Commons::Uri::UESURI.new(commandUri).to_java
    command = Ues::Core::Sysc::CommandGetExportData.new(command).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Command.java_class)
    _r = _s.getExportData(commandUri, command)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::Command
    alias export_data getExportData
  end
end
