#--
# This code is automatically generated, do not modify the content !!!
#++
class Ues::Core::Sysc::Widget
  private_class_method :new

  BE_WIDGET_CODE = Java::cz.ues.core.sysc.Widget::BE_WIDGET_CODE #:nodoc:

  # URI of Widget business entity.
# 
# <tt><b>since</b></tt> UES8-15
  BETYPE_WIDGET = Java::cz.ues.core.sysc.Widget::BETYPE_WIDGET


# Creates a widget in specified location. At the very least meta artifact must be specified in WidgetCreate object.
# Competent role for the new widget will be selected as the most suitable according to specified package and meta artifact
# (executive/authorized role with connected interface), or can be also specified in WidgetCreate Object.
# 
# <tt><b>param</b></tt> locationUri UESURI of the meta model where the widget will be created.
# 
# <tt><b>param</b></tt> widget DTO containing attributes of the new widget.
# 
# <tt><b>return</b></tt> UESURI of the new widget.
# 
# <tt><b>since</b></tt> UES8-15
  def self.create(locationUri, widget = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    widget = Ues::Core::Sysc::WidgetCreate.new(widget).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Widget.java_class)
    _r = _s.create(locationUri, widget)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command deletes the specified widget from the system. The command fails when the specified widget is referenced by some use case.
# The widget is deleted even if it contains a locked sheet or attachment.
# 
# <tt><b>param</b></tt> widgetUri UESURI of the widget which is about to be deleted.
# 
# <tt><b>since</b></tt> UES8-15
  def self.delete(widgetUri)
    widgetUri = Ues::Core::Commons::Uri::UESURI.new(widgetUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Widget.java_class)
    _r = _s.delete(widgetUri)
    
    return _r
  end

# This command returns attributes representing the widget specified by the widgetUri parameter.
# 
# <tt><b>param</b></tt> widgetUri UESURI of the widget.
# 
# <tt><b>return</b></tt> DTO containing attributes of the widget.
# 
# <tt><b>since</b></tt> UES8-15
  def self.getAttributes(widgetUri)
    widgetUri = Ues::Core::Commons::Uri::UESURI.new(widgetUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Widget.java_class)
    _r = _s.getAttributes(widgetUri)
    if (_r != nil) then _r = Ues::Core::Sysc::WidgetAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::Widget
    alias attributes getAttributes
  end

# Sets attributes of widget. Command cannot modify references to objects like location, competent role and so on.
# Changing the code of the widget will cause malfunction of widget instances.
# 
# <tt><b>param</b></tt> widgetUri UESURI of the widget.
# 
# <tt><b>param</b></tt> widget DTO containing new attributes of the widget.
# 
# <tt><b>return</b></tt> UESURI of the widget.
# 
# <tt><b>since</b></tt> UES8-15
  def self.setAttributes(widgetUri, widget = nil)
    widgetUri = Ues::Core::Commons::Uri::UESURI.new(widgetUri).to_java
    widget = Ues::Core::Sysc::WidgetSetAttributes.new(widget).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Widget.java_class)
    _r = _s.setAttributes(widgetUri, widget)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::Widget
    alias set_attributes setAttributes
  end

# Returns the list of widgets whose instances can be inserted into the content of selected sheet or into the content of a sheet on a given Artifact.
# Returned list does not contain any objects filtered out by executed UESQuery. The list is sorted by the
# name (and codes in case are equal) of an widget by default. See Also: <a>UES Query Documentation</a>.
# 
# <tt><b>param</b></tt> entityUri UESURI of the sheet or artifact for which the available widgets are to be listed.
# 
# <tt><b>param</b></tt> citeria DTO containing criteria for listing widgets.
# 
# <tt><b>return</b></tt> List of DTO representing widgets available to the sheet.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm? &SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>since</b></tt> UES8-15
  def self.getWidgetList(entityUri, citeria = nil)
    entityUri = Ues::Core::Commons::Uri::UESURI.new(entityUri).to_java
    citeria = Ues::Core::Sysc::WidgetGetWidgetList.new(citeria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Widget.java_class)
    _r = _s.getWidgetList(entityUri, citeria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::Widget
    alias widget_list getWidgetList
  end

# Returns list of the widgets that are registered within the application or within the territory . The list of returned widgets can be
# filtered by the name or code. Returned list does not contain any objects filtered out by executed UESQuery. The list is sorted by the
# name (and codes in case are equal) of an widget by default. See Also: <a>UES Query Documentation</a>.
# 
# <tt><b>param</b></tt> containerUri UESURI of the territory or the application for which the widgets are to be listed.
# 
# <tt><b>param</b></tt> citeria DTO containing criteria for listing widgets.
# 
# <tt><b>return</b></tt> List of DTO representing widgets.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm? &SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>since</b></tt> UES8-15
  def self.getRegisteredWidgetList(containerUri, citeria = nil)
    containerUri = Ues::Core::Commons::Uri::UESURI.new(containerUri).to_java
    citeria = Ues::Core::Sysc::WidgetGetWidgetList.new(citeria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Widget.java_class)
    _r = _s.getRegisteredWidgetList(containerUri, citeria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::Widget
    alias registered_widget_list getRegisteredWidgetList
  end

# The command exports a widget to a DataFile, which is saved to the Export Storage. The export is an asynchronous event. That is why it
# returns a process URI to enable the user to wait for the process to finish.
# 
# <tt><b>param</b></tt> widgetUri UESURI of the widget to export
# 
# <tt><b>param</b></tt> widget  DTO that contains attributes of the export process
# 
# <tt><b>return</b></tt> UESURI of the export process
# 
# <tt><b>throws</b></tt> WidgetRTException
# 
# <tt><b>since</b></tt> UES8-15
  def self.export(widgetUri, widget = nil)
    widgetUri = Ues::Core::Commons::Uri::UESURI.new(widgetUri).to_java
    widget = Ues::Core::Sysc::WidgetExport.new(widget).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Widget.java_class)
    _r = _s.export(widgetUri, widget)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command returns a data file generated by the export command. The file contains an exported widget.
# 
# <tt><b>param</b></tt> widgetUri UESURI of the widget we want to get the exported file from.
# 
# <tt><b>param</b></tt> widget DTO that contains attributes concerning the file returned.
# 
# <tt><b>return</b></tt> Data file of an exported widget.
# 
# <tt><b>throws</b></tt> WidgetRTException
# 
# <tt><b>since</b></tt> UES8-15
  def self.getExportData(widgetUri, widget = nil)
    widgetUri = Ues::Core::Commons::Uri::UESURI.new(widgetUri).to_java
    widget = Ues::Core::Sysc::WidgetGetExportData.new(widget).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Widget.java_class)
    _r = _s.getExportData(widgetUri, widget)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Sysc::Widget
    alias export_data getExportData
  end

  # :stopdoc:
  def self.getRegisteredWidgetListInternal(uri)
    uri = Ues::Core::Commons::Uri::UESURI.new(uri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.sysc.Widget.java_class)
    _r = _s.getRegisteredWidgetListInternal(uri)
    if (_r != nil) then _t = []; _r.to_a.each do |_e|; if (_e != nil) then _e = Ues::Core::Sysc::WidgetGetWidgetListItem.new(_e) end; _t << _e; end; _r = _t; end;
    return _r
  end
  class << Ues::Core::Sysc::Widget
    alias registered_widget_list_internal getRegisteredWidgetListInternal
  end
  # :startdoc:
end
