#--
# This code is automatically generated, do not modify the content !!!
#++
# Component for managing Entity Registry data.
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-00
class Ues::Platform::Sysc::Entitytype::UESEntityTypeRegistry
  private_class_method :new


# Creates new Entity Type. Required attribute is Entity Type code.
# 
# <tt><b>param</b></tt> sysTer UESURI of system territory where to create Entity Type
# 
# <tt><b>param</b></tt> createEntityType DTO of created Entity Type
# 
# <tt><b>return</b></tt> Normalized UESURI of created Entity Type
# 
# <tt><b>throws</b></tt> UESEntityTypeRegistryRTException in case Entity Type cannot be created or creation fails
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-00
  def self.createEntityType(sysTer, createEntityType = nil)
    sysTer = Ues::Platform::Commons::Uri::UESURI.new(sysTer).to_java
    createEntityType = Ues::Platform::Sysc::Entitytype::DTOCreateEntityType.new(createEntityType).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.entitytype.UESEntityTypeRegistry.java_class)
    _r = _s.createEntityType(sysTer, createEntityType)
    if (_r != nil) then _r = Ues::Platform::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Platform::Sysc::Entitytype::UESEntityTypeRegistry
    alias create_entity_type createEntityType
  end

# Deletes Entity Type. Entity Type must be leaf and must not be associated
# with other Entity Types in order to be able to remove it. If given Entity
# Type does not exist, method does nothing.
# 
# <tt><b>param</b></tt> sysTer UESURI of system territory where to delete Entity Type
# 
# <tt><b>param</b></tt> mainETUri UESURI of Entity Type to be deleted
# 
# <tt><b>throws</b></tt> UESEntityTypeRegistryRTException in case Entity Type cannot be deleted or deletion of Entity Type fails
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-00
  def self.deleteEntityType(sysTer, mainETUri = nil)
    sysTer = Ues::Platform::Commons::Uri::UESURI.new(sysTer).to_java
    mainETUri = Ues::Platform::Commons::Uri::UESURI.new(mainETUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.entitytype.UESEntityTypeRegistry.java_class)
    _r = _s.deleteEntityType(sysTer, mainETUri)
    
    return _r
  end
  class << Ues::Platform::Sysc::Entitytype::UESEntityTypeRegistry
    alias delete_entity_type deleteEntityType
  end

# Updates existing Entity Type. Null value attributes are unchanged.
# 
# <tt><b>param</b></tt> sysTer UESURI of system territory where to update Entity Type
# 
# <tt><b>param</b></tt> mainETUri UESURI of updated Entity Type
# 
# <tt><b>param</b></tt> updateEntityType Attributes to be set on existing Entity Type
# 
# <tt><b>throws</b></tt> UESEntityTypeRegistryRTException in case update of Entity Type fails
# 
# <tt><b>author</b></tt> uni430
# 
# <tt><b>since</b></tt> UES7-00
  def self.setEntityTypeAttributes(sysTer, mainETUri, updateEntityType)
    sysTer = Ues::Platform::Commons::Uri::UESURI.new(sysTer).to_java
    mainETUri = Ues::Platform::Commons::Uri::UESURI.new(mainETUri).to_java
    updateEntityType = Ues::Platform::Sysc::Entitytype::DTOUpdateEntityType.new(updateEntityType).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.platform.sysc.entitytype.UESEntityTypeRegistry.java_class)
    _r = _s.setEntityTypeAttributes(sysTer, mainETUri, updateEntityType)
    
    return _r
  end
  class << Ues::Platform::Sysc::Entitytype::UESEntityTypeRegistry
    alias set_entity_type_attributes setEntityTypeAttributes
  end
end
